﻿#SingleInstance OFF
#MaxThreadsPerHotkey 2
#MaxThreads 30
#NoEnv
#Persistent
#NoTrayIcon
#InstallKeybdHook
#InstallMouseHook
#MaxMem 100
#Include %A_ScriptDir%\lib\!Includes.ahk

if A_OSVersion in WIN_NT4,WIN_95,WIN_98,WIN_ME
{
    MsgBox This programm requires Windows 2000/XP or later.
    ExitApp
}
SetWorkingDir, %A_ScriptDir%
SetBatchLines, -1
OnExit, ExitProcessing
Process, priority,,H
Menu, tray, UseErrorLevel
Menu, tray, Tip, %MB_NAME%
FileEncoding, UTF-16
A_Isx64 := A_PtrSize = 8 ? 1 : 0	;defining global var to determine if build x64
A_QCarch := A_Isx64 = 1 ? "x64" : "x32"
ComObjError(1)
CoordMode, Mouse, Screen
CoordMode, Menu, Screen
global_NoGuiTheme := GetGuiThemeState()
oGuiTooltip := new GuiTooltip()
TBB_size := 8+3*A_PtrSize
params = %0%	;number of parameters
param1 = %1%	;="-a" for new shortuct GUI
param2 = %2%	;path to the file to which we need create a shortcut
CheckArguments(params,param1,param2)

IfNotExist, %MENUITEMSINI%
	FirstRun = 1
CheckIniEncoding()
TrayTip,, %MB_NAME% successfully started!, 5
;----------------------------------------------------------
Menu, Tray, Icon,,,1								;disabling changing to "S" icon
if (OptGet("HideTrayIcon") = 1)
	Menu, Tray, NoIcon
Else
	Menu, Tray, Icon
;----------------------------------------------------------
itemname := ItemGet(0,MAIN_SECTION_NAME)
if (itemname == "ERROR")
	ItemSet(0,MAIN_SECTION_NAME,"-empty-")
;################### Important initializations
DF_SetIconsHandle()
opt := new QC_Options()
MMenu_InitArrays()
MenuRebuild(MAIN_SECTION_NAME)
SetStartupShortcut()
;###################
if (A_IsCompiled != 1)		;if not compiled instance runned
{
	Hotkey("!r",1,"restart")
	Hotkey("!h",1,"listhotkeys")
}
if A_IsCompiled
	SetTimer, SilentUpdateCheck, -120000
OnMessage(0x7777, "Mreb") ;used for adding shortcut through context menu
OnMessage(0x7778, "ShellCM") ;show context menu
if (OptGet("smenu_on")=1 && A_IsCompiled)
	CheckSMenuRegs()

;;;;Open Tutorial Here
If FirstRun
	{
		MsgBox, 64, Welcome To Quick Cliq!, It appears this is your first time running Quick Cliq. Welcome!`n`nUse the default hotkey "Win+Z" to open the main menu.`nYou may also use the default mouse gesture by holding the right mouse button and dragging down.`n`nDon't wait, try it right now!`n`nHold CTRL while navigating through the menu to get description of selected item`nUse the "Add/Change" menu item to start adding items or get some help!`n`nThanks for using Quick Cliq!`n-Apathy Softworks`n`nVersion - %PROGRAM_VERSION%
	FirstRun = 
	}
QC_START_TIME := A_NOW
if (GetClipsState() && GetClipsSave())
	RestoreClips()

return
;########################--END-OF-INIT-################################
Mreb()
{
	global
	MenuRebuild(MAIN_SECTION_NAME)
	return
}
;########################

GesturesSub:
	Gesture := MG_Recognize("",0,4)
	if (Gesture_Clipx_enabled = 1 && Gesture = ClipXGesture && ClipXEnabled = 1)
		{
			Gosub, ShowClipsMenu
			return
		}
	if (Gesture_Main_enabled = 1 && Gesture = MainGesture)
		{
			Gosub, OpenMenu
			return
		}
	if (Gesture_WH_enabled = 1 && Gesture = WinHideGesture && Win_Hide_Enabled = 1)
		{
			Gosub, ShowWinHideMenu
			return
		}
	if (Gesture_Memos_enabled = 1 && Gesture = Memos_Gesture && Memos_On = 1)
		{
			Gosub, ShowMemos
			return
		}
	if (Gesture_Recent_enabled = 1 && Gesture = GS_Recent_Gesture && Recent_On = 1)
		{
			Gosub, ShowRecent
			return
		}	
	return

OpenMenu:
	if !HotKeysAllowed
	{
		DTP("Please wait...",1000)
		return
	}
	MouseGetPos,X,Y
	xshift := 0
	yshift := 0
	if (A_ThisHotkey = "~LButton & RButton")
	{
		If (X > A_ScreenWidth-150)
			xshift := 4
		else
			xshift := -4
		If (Y > A_ScreenHeight-250)
			yshift := 4
		else
			yshift := -4
	}
	WinGet, window, ID, A
	GetDesktopSelection(window)
	Clip_X_CheckMenus2()
	MMenu_Show(QC_MMenus[MAIN_SECTION_NAME],X+xshift,Y+yshift, "RunTarget","SSelectHandle UMenuCloseHandle RRBHandle IMenuOpenHandle MMBHandle",MM_TRANSPARENCY)
	return

ShowClipsMenu:
	if !HotKeysAllowed
	{
		DTP("Please wait...",1000)
		return
	}
	MouseGetPos, X,Y
	Clip_X_CheckMenus2()
	MMenu_Show(clipXhandl,X,Y, "RunTarget","SSelectHandle UMenuCloseHandle IMenuOpenHandle",MM_TRANSPARENCY)
	return

ChangeClips: ;sub running on using clip-changing hotkeys
	ProcessClipsCommand(A_ThisHotkey)
	return

ShowWinHideMenu:
	if !HotKeysAllowed
	{
		DTP("Please wait...",1000)
		return
	}
	WinGet, window, ID, A
	MouseGetPos, X,Y
	MMenu_Show(Windows_menu,X,Y, "RunTarget","SSelectHandle UMenuCloseHandle IMenuOpenHandle",MM_TRANSPARENCY)
	return

Win_Hotkey_Ex:
	if (Allow_hide_hotkey = 0)
		return
	WinGet, active_Win_ID, ID, A		;getting ID of active window and then title is more reliable way, because id unique, but title not
	On_Hide_Window(active_Win_ID)
	Return

ShowMemos:
	if !HotKeysAllowed
	{
		DTP("Please wait...",1000)
		return
	}
	WinGet, window, ID, A
	MouseGetPos, X,Y
	MMenu_Show(MemosHandl,X,Y, "RunTarget","SSelectHandle UMenuCloseHandle IMenuOpenHandle",MM_TRANSPARENCY)
	return

ShowRecent:
	if !HotKeysAllowed
	{
		DTP("Please wait...",1000)
		return
	}
	MouseGetPos, X,Y
	MMenu_Show(RecentHandl,X,Y, "RunTarget","SSelectHandle UMenuCloseHandle IMenuOpenHandle",MM_TRANSPARENCY)	
	return

;###########################################################
restart:
Reload
return
;##########################ADDMENUGUI#################################
ADDMENUGUI:
AddMenuGui()
return

;##########################RUNTARGET################################# Catches Menu Clicks
RunTarget:
	;multi-threading emulation
	thrds_cnt := 0
	sleep -1
	Loop
	{
		if (grtc_%thrds_cnt%_busy = 1)
		{
			thrds_cnt++
			if (thrds_cnt > 5)
			{
				MsgBox,64,Please Wait,Reached maximum number of simulteniously running targets.`nPlease wait until some of them finished.
				return
			}
		}
		else
			break
	}
	SetTimer,RunTarget_Thread%thrds_cnt%,-1
	return

RunTarget_Thread0:
RunTarget_Thread1:
RunTarget_Thread2:
RunTarget_Thread3:
RunTarget_Thread4:
RunTarget_Thread5:
;~ WinHide, ahk_id %selected_win_handle%
thread_num := SubStr(A_ThisLabel,0)
grtc_%thread_num%_busy := 1
if (selected_win_handle && !RegExMatch(M_ID,"Win_Hide_0x[0-9]*"))							;if hided window is shown
	{
		WinSet, Transparent, 0, ahk_id %selected_win_handle%
		WinHide, ahk_id %selected_win_handle%
		selected_win_handle =						;if previewed window was choosed to be shown
	}
if (M_ID == MAIN_SECTION_NAME . "#AddChange") ;if Add/Change is clicked
{
	if (GetKeyState("Ctrl","P") && GetKeyState("LWin","P"))
		ExitApp
	Gosub ADDMENUGUI
}
else if InStr(M_ID,"HK_Susp")
		GoSub, HotkeysSuspend
else if InStr(M_ID,"GS_Susp")
	{
		if GetKeyState("Ctrl","P")
		{
			grtc_%thread_num%_busy := 0
			Goto, GesturesSuspend_Timer
		}
		GoSub, GesturesSuspend
	}
else if InStr(M_ID,"Memos_") ;if Memo item is run
		MemosActions(M_ID)
else if InStr(M_ID,"ClipX_") ;if ClipX item is run
		Clip_X_Func(M_ID)
else If InStr(M_ID, "Win_Hide_") ;If Win_Hide menu is run
{
	if (M_ID = "Win_Hide_Active_Window")
	{
		sleep, 300
		On_Hide_Window(window)
	}
	else if (M_ID = "Win_Hide_Show_All")
		On_Show_All_Windows()
	else if (M_ID = "Win_Hide_ToggleOnTop")
		Toggle_Win_OnTop(window)
	else if	(M_ID = "Win_Hide_ChangeTransp")
		Change_Active_Window_Transp(window)
	else if	(M_ID = "Win_Hide_ToggleCloseBT")
		CloseBT_Toggle(window)
	else if (M_ID = "Win_Hide_ToggleDesktop")
		WinCmd("win_togd")
	else if (M_ID = "Win_Hide_Tile_Horizontally")
		WinCmd("win_tileh")
	else if (M_ID = "Win_Hide_Tile_Vertically")
		WinCmd("win_tilev")
	else if (M_ID = "Win_Hide_Cascade")
		WinCmd("win_casc")
	else
	{
		StringTrimLeft, M_ID, M_ID, 9
		On_Show_Window(M_ID)
	}
}
else If InStr(M_ID, "Recent_")
		RecentProcessActions(M_ID)
else if (M_ID = "QuickHelp")
		Help()
else if (GetKeyState("SHIFT","P") && RegExMatch(M_ID, "^" . MAIN_SECTION_NAME . "#"))
	EditShortcut(M_ID,M_TITLE)
else if RegExMatch(M_ID,"^DF_\K.*",df_id)
{
	if RegExMatch(df_id,"^DFM_\K[0-9]+",menu_id)
	{
		if RegExMatch(df_menus,"`am)^" . menu_id . "\|\K.+?$",tg)
			RunTarget(tg,0,"Folder Menu")
	}
	else
		if RegExMatch(df_targets,"`am)^" . df_id . "\|\K.+?$",tg)
			RunTarget(tg,0,"Folder Menu")
}
else
{
	target := ItemGet(M_ID,"Targets")
	if (target != "" && target != "ERROR")
		RunTarget(target,0,M_TITLE,M_ID)
	else
		DTP("Target empty!",2000)
}
thread_num := SubStr(A_ThisLabel,0)
grtc_%thread_num%_busy := 0
sleep -1
return

;~ !e::
	;~ retval := DllCall("SetCurrentDirectoryA","str","..")
	;~ reqbuf := DllCall("GetCurrentDirectoryA","UInt",0,"UInt",0)
	;~ VarSetCapacity(curdir,reqbuf)
	;~ DllCall("GetCurrentDirectoryA","UInt",reqbuf,"UInt",&curdir)
	;~ msgbox % curdir
	;~ retval := DllCall("SetCurrentDirectoryA","str",A_ScriptDir)
	;~ reqbuf := DllCall("GetCurrentDirectoryA","UInt",0,"UInt",0)
	;~ VarSetCapacity(curdir,reqbuf)
	;~ DllCall("GetCurrentDirectoryA","UInt",reqbuf,"UInt",&curdir)
	;~ msgbox % curdir
	;~ return

RBHandle:
	if (GetKeyState("SHIFT","P") && RegExMatch(M_SID, "^" . MAIN_SECTION_NAME . "#") && !Instr(M_SID,MAIN_SECTION_NAME . "#AddChange"))
		DeleteItemByTarget(M_SID,M_STITLE,M_SMENU)
	else if (GetKeyState("CTRL","P") && Made_Selection = 1)
		SetTimer, ChangeFolderTo, -10
	else
		SetTimer, OpenContextMMenu, -50
	return

MBHandle:
	SetTimer, ChangeFolderTo, -1
	return

ChangeFolderTo:
	ChangeFolderTo(window,M_SID)
	return

OpenContextMMenu:
	if RegExMatch(M_SID,"^DF_\K.*",df_id)
	{
		if RegExMatch(df_id,"^DFM_\K[0-9]+",menu_id)
		{
			if RegExMatch(df_menus,"`am)^" . menu_id . "\|\K.+?$",tg)
				contx_ret := ShellContextMenu(tg)
		}
		else
			if RegExMatch(df_targets,"`am)^" . df_id . "\|\K.+?$",tg)
				contx_ret := ShellContextMenu(tg)
		if contx_ret
			MMenu_Hide()			;close MMenu if any item was selected from context menu
	}
;~ 	OpenContextMMenu(M_SID,M_STITLE,M_SMENU)
	return

MenuOpenHandle:							;Getting first menu ID
	if !first_menu_id
		first_menu_id := M_MENU
	MenuWatch_T := 0
	SetTimer,WatchForMenu,10
	if !instr(df_built_menus,"|" . M_MENU . "|")
	{
		SetTimer,BuildFM,-1
		fm_last_menu := M_MENU
	}
	return

BuildFM:
	DF_BuildDir(fm_last_menu)	
	return

MenuCloseHandle:
	Tooltip
	settimer,ShowNoIconsTooltip,OFF
	SetTimer, Hide_S_Window, -200		;used to avoid flashing in case if previewed window was selected to show
	Made_Selection = 0
	if (M_MENU = first_menu_id)
	{
		first_menu_id =
		DetectHiddenWindows,On
		WinKill, ahk_id %MMenu_hParent%
		DetectHiddenWindows,Off
	}
	return

WatchForMenu:
	Thread, interrupt, 0
	if (MenuWatch_T = 30 || MMenu_trans = 255 || MMenu_trans = "")
	{
		SetTimer,WatchForMenu,OFF
		return
	}
	DetectHiddenWindows, On
	WinGet,	transp_level, Transparent, ahk_class #32768
	if (transp_level == MMenu_trans)
	{
		MenuWatch_T++
		return
	}
	IfWinExist, ahk_class #32768
		WinSet, Transparent,% MMenu_trans ; Uses the window found by the above line.
	MenuWatch_T++
	return

Hide_S_Window:
	if selected_win_handle
	{
		WinSet, Transparent, 0, ahk_id %selected_win_handle%
		WinHide, ahk_id %selected_win_handle%
		selected_win_handle =
	}
	return

SelectHandle:
	SetTimer,SelectHandle_Thread,-1
	return

ShowNoIconsTooltip:
	tooltip % global_NoIconsTooltip
	return

SelectHandle_Thread:
	Tooltip
	settimer,ShowNoIconsTooltip,OFF
	Made_Selection = 1
	#WinActivateForce										;this allow previewed window shows without closing popup menu
	PMMenu_ID := WinExist("A")

	DetectHiddenWindows, ON
	if selected_win_handle									;if hided window is shown
		{
			WinSet, Transparent, 0, ahk_id %selected_win_handle%
			WinHide, ahk_id %selected_win_handle%
			selected_win_handle =
		}

	if InStr(M_SID,"Recent_ii_")
	{
		ShowRecentItemTooltip(M_SID)
		return
	}
	
	if !GetKeyState("CTRL","P")					;all subsequent command only works if CTRL holded
	{
		if (global_ShowTooltip && InStr(M_SID,MAIN_SECTION_NAME . "#"))
		{
			global_NoIconsTooltip := M_STITLE
			settimer,ShowNoIconsTooltip,-600
		}
		return
	}

	if InStr(M_SID,MAIN_SECTION_NAME . "#AddChange")	;tooltip for Add/Change item
	{
		Tooltip Allows you to add/change menu items`, colors and settings`n`nctrl+win+click - close %MB_NAME%
		return
	}
	if (M_SID = "QuickHelp")
	{
		Tooltip List of enabled features`, hotkeys`, gestures
		return		
	}
	if InStr(M_SID,MAIN_SECTION_NAME . "#")		;shows target of focused shortcut
		{
			Item_target := ItemGet(M_SID,"Targets")
			if (Item_target = "ERROR")
			{
				Item_target =
				Tooltip %M_STITLE%
			}
			else
			{
				targets_list := GetTargetsList(Item_target)
				Tooltip %M_STITLE%`n`nTarget(s):`n%targets_list%`n`nSHIFT+Left Click - open selected shortcut for editing`nSHIFT+Right Click - delete choosen shortcut/menu`nCTRL+Left Click - copy target to clipboard`nCTRL+Right Click - fast folder change`nMiddle Click - fast folder change
				isExist =
				Item_target =
				targets_list =
			}
			return
		}
	if (InStr(M_SID,"Win_Hide_") && M_SID != "Win_Hide_Menu")				;show transparent preview for hiden window
		{
			StringTrimLeft, selected_win_handle, M_SID, 9
			if selected_win_handle is Xdigit
			{
				WinActivate, AHK_ID %selected_win_handle%
				transparent_level := OptGet("transparent_level")
				if transparent_level is not Digit
					transparent_level := DEFAULT_TRANSP_LEVEL
				WinSet, Transparent, %transparent_level%, ahk_id %selected_win_handle%
				WinShow, ahk_id %selected_win_handle%
				WinActivate, AHK_ID %PMMenu_ID%
			}
			else
				selected_win_handle =
			return
		}
	
	if RegExMatch(M_SID,"^Memos_[0-9]+$")
	{
		ShowMemoPreview(M_SID,M_STITLE)				;function in the memos.ahk
		return
	}
	
	if InStr(M_SID,"HK_Susp")				;tooltip for hotkeys suspend
	{
		Tooltip Suspend all hotkeys except Main Menu hotkey`nUseful in certain applications like Photoshop or games
		return
	}

	if InStr(M_SID,"GS_Susp")				;tooltip for gestures suspend
	{
		Global_Gesture_Disable_Time := OptGet("Gesture_Disable_Time")
		if (Global_Gesture_Disable_Time = "ERROR" or Global_Gesture_Disable_Time = "")
			Global_Gesture_Disable_Time := 10000 ; 10 Seconds
		StringTrimRight, TempDisableValue, Global_Gesture_Disable_Time, 3
		Tooltip Suspend all mouse gestures`n`nCTRL + Click - Temporarily suspend gestures for %TempDisableValue% second(s)`nYou may set the delay time in the settings
		return
	}
	
	if RegExMatch(M_SID,"^ClipX_Clip[0-9]+$")
	{
		ShowClipPreview(M_SID)				;function in the clipx.ahk
		return
	}	
	
	DetectHiddenWindows, OFF
	return

listhotkeys:
ListHotkeys
return

;################ ABOUT #########################
ABOUT:
About()
return
;################ EXIT ##########################
ExitProcessing:				;OnExit sub
EXIT:
	If !Exit_NoNotify
	{
		if A_ExitReason in Menu,Exit
		{
			FileReadLine, Are_Wins_Hidden, %WINDOWS_INI%, 2 ;Reading the second line of the Windows.ini to see if there are any hidden windows
			If !ErrorLevel
				{
					MsgBox, 36, Windows Hidden!, There are still some windows that are hidden.`nWould you like to show them now?`n`n(You may still show them when you restart Quick Cliq if the processes for these windows exist)
					IfMsgBox, Yes
						On_Show_All_Windows()
				}
		}
		SaveUseTime()
		if GetClipsSave()
			SaveClips()
	}
	ExitApp
	return

SilentUpdateCheck:
	AutoUpdates := OptGet("AutoUpdates")
	if AutoUpdates not in 0,1
		AutoUpdates := DEFAULT_AUTOUPDATE
	if AutoUpdates
		Program_Update(1,1)
	return
	
HotkeysSuspend:
	Menu,tray, Rename,% isSuspended := HotkeysGlobalState = 1 ? "Hotkeys ON" : "Hotkeys OFF",% isSuspended := HotkeysGlobalState = 1 ? "Hotkeys OFF" : "Hotkeys ON"
	if HotkeysGlobalState
	{
		MMenu_Set(SuspendMenuHandle, "HK_Susp", "Hotkeys OFF", SUSPEND_OFF_ICO, "")
		SuspendHotkeys("OFF")
		OptSet("HotkeysGlobalState",0)
	}
	else
	{
		MMenu_Set(SuspendMenuHandle, "HK_Susp", "Hotkeys ON",SUSPEND_ON_ICO,"")
		SuspendHotkeys("ON")
		OptSet("HotkeysGlobalState",1)
	}
	HotkeysGlobalState := OptGet("HotkeysGlobalState")
return

GesturesSuspend_Timer:
	isNotify := GetTGNotifyState()
	Global_Gesture_Disable_Time := OptGet("Gesture_Disable_Time")
	if (Global_Gesture_Disable_Time = "ERROR" or Global_Gesture_Disable_Time = "")
		Global_Gesture_Disable_Time := 10000 ; 10 Seconds
	if !GesturesGlobalState
	{
		if isNotify
			DTP("Gestures will be restored in " . Round(Global_Gesture_Disable_Time/1000) . " seconds",2000)
	}
	else
	{
		if isNotify
			DTP("Gestures have been suspended for " . Round(Global_Gesture_Disable_Time/1000) . " seconds!",2000)
		Gosub, GST
	}
	SetTimer, GST, -%Global_Gesture_Disable_Time%
	Gestures_Temp_Disabled = 1
	Return

GST:
GesturesSuspend:
	If Gestures_Temp_Disabled		;If Gestures have been temporarily suspended we turn the timer off and set its variable to null
		{
			SetTimer, GST, Off
			if (A_ThisLabel = "GST")
			{
				if isNotify
					DTP("Gestures have been restored!",2000)
			}
			Gestures_Temp_Disabled = 
		}
	Menu,tray, Rename,% GesturesState := GesturesGlobalState = 1 ? "Gestures ON" : "Gestures OFF",% GesturesState := GesturesGlobalState = 1 ? "Gestures OFF" : "Gestures ON"
	if GesturesGlobalState
	{
		MMenu_Set(SuspendMenuHandle, "GS_Susp", "Gestures OFF", SUSPEND_OFF_ICO, "")
		SetGestureGuiMatch(0)
		OptSet("GesturesGlobalState",0)
	}
	else
	{
		MMenu_Set(SuspendMenuHandle, "GS_Susp", "Gestures ON", SUSPEND_ON_ICO,"")
		SetGestureGuiMatch(1)
		OptSet("GesturesGlobalState",1)
	}	
	GesturesGlobalState := OptGet("GesturesGlobalState")
	TrayTip		;Turning Off TrayTip
	return
	
Recent_CheckActiveFolders:
	CheckActiveFolders()
	return

Recent_CheckWindowsRecentFolder:
	CheckWindowsRecent()
	return

DisMess:		
	if (HelpGRunning || ClipsGuiRunning || MemosGuiRunning || MainGuiRunning)
		return
	else
	{
		Emptymem()
		SetTimer,DisMess,OFF
	}
	return

;############ CUSTOM HOKEYS
	
CustomHotkeys_RunSub:
	CHK_RunHotkey := A_ThisHotkey
	thrds_cnt := 0
	sleep -1
	Loop
	{
		if (chk_run_%thrds_cnt%_busy = 1)
		{
			thrds_cnt++
			if (thrds_cnt > 5)
			{
				MsgBox,64,Please Wait,Reached maximum number of simulteniously running targets.`nPlease wait until some of them finished.
				return
			}
		}
		else
			break
	}
	SetTimer,CustomHotkeys_Thread%thrds_cnt%,-1	
	return
	
CustomHotkeys_Thread0:
CustomHotkeys_Thread1:
CustomHotkeys_Thread2:
CustomHotkeys_Thread3:
CustomHotkeys_Thread4:
CustomHotkeys_Thread5:
thread_num := SubStr(A_ThisLabel,0)
chk_run_%thread_num%_busy := 1
ProcessCustomHotkey(CHK_RunHotkey)
chk_run_%thread_num%_busy := 0
sleep -1
return
	
; ########################## S-MENU SUBS
RunSMenuTarget:
	RunSMenuTarget(M_ID,M_TITLE)
	return
SM_SelectHandle:
	SM_SelectHandle(M_SID)
	return
SM_RBHandle:
	SM_RBHandle()
	return
SM_MenuCloseHandle:
	SM_MenuCloseHandle(M_MENU)
	return
SM_MenuOpenHandle:
	SM_MenuOpenHandle(M_MENU)
	return
SM_MBHandle:
	SM_MBHandle()
	return

ApplyMemosChangesHK:
	MemosSaveChanges()
	return
	
MG_ShowProps:
	MG_ItemPropsGUI()
	return
