﻿PROGRAM_VERSION := "1.3.7"

PATH_SIZE := 260*2+1

MB_NAME := "Quick Cliq"
MEMOS_TITLE := "Memos"
SYS_GUI_TITLE := "System Shortcuts"
PROPS_GUI_TITLE := "Item Properties"
NO_ICO_NUM := 20000

MAIN_SECTION_NAME := "Main"
SEPARATOR_STRING := "-------------<"
CONTX_MENU = Add to %MB_NAME%
CLIP_X_MENU_NAME := "ClipX_Menu"
QC_SMENU_REGNAME := "QuickCliq_S_Menu"
WIN_RECENT_FOLDER := GetRecentFolder()

PROGRAM_PATH := A_ScriptDir . "\Data"
USER_ICONS := "Data\user_icons"
MEMOS_PATH := PROGRAM_PATH "\Memos"
SETSNAME := PROGRAM_PATH "\settings.ini"
MENUITEMSINI := PROGRAM_PATH "\menu_items.ini"
WINDOWS_INI := PROGRAM_PATH "\windows.ini"
CLIPS_SAVEDIR := PROGRAM_PATH "\Clips"

QC_ICL := "Data\qc_icons.icl:"
SUSPEND_ON_ICO := QC_ICL . "10"
SUSPEND_OFF_ICO := QC_ICL . "9"
ADD_CHANGE_ICO := QC_ICL . "6"
CLIPX_ICO := QC_ICL . "1"
WINHIDE_ICO := QC_ICL . "8"
MEMOS_ICO := QC_ICL . "7"
DF_ICO := QC_ICL . "4"
NOICO := QC_ICL . "16"
RECENT_ICO := QC_ICL . "11"
HELP_ICO := QC_ICL . "5"
SUSPEND_ICO := QC_ICL . "13"
REMOTE_ICO := QC_ICL . "12"
SYSTEM_FOLDER := QC_ICL . "14"
FOLDER_ICO := QC_ICL . "3"
EMAIL_ICO := QC_ICL . "2"
URL_ICO := QC_ICL . "15"
PROP_ICO_IND := 16
PROP_ICO_CNT := 8
IE_ICO_IND := PROP_ICO_IND + PROP_ICO_CNT
IE_ICO_CNT := 8
MG_ICO_IND := IE_ICO_IND + IE_ICO_CNT
MG_ICO_CNT := 10
CMD_OUT_ICO := QC_ICL . ( MG_ICO_IND + MG_ICO_CNT )
CMD_IN_ICO := QC_ICL . ( MG_ICO_IND + MG_ICO_CNT + 1 )
QC_ICO := QC_ICL . "0"

HELP_URL := "http://apathysoftworks.com/qc_help_redirect.php"
NEWS_URL := "http://apathysoftworks.com/qc_news_redirect.php"
FACEBOOK_URL := "http://www.facebook.com/pages/Apathy-Softworks/109468265754240"
TWITTER_URL := "http://twitter.com/DeoWhite/apathy-softworks"
DONATE_URL := "http://apathysoftworks.com/donate"
REDIRECT_URL := "http://apathysoftworks.com/qc_gui_redirect.php"
HOME_REDIRECT_URL := "http://apathysoftworks.com/qc_apathy_home_redirect.php"

ICON_OFFSET := 8
cnn:=0
DEFAULT_MULTI_TARGET_DELAY := 300				;ms
MULTI_TARGET_DIVIDER := "{N}" 
MM_TRANSPARENCY := GetMenusTrans()
RC_MAXITEMS := 30
RC_MINITEMS := 2
AFO_DELAY := 30000
;########### COLORS CONSTS
TEXT_COLOR_DEFAULT := "000000"
MENU_COLOR_DEFAULT := "f1f1f1"

DEFAULT_SHOW_IN_MAIN := 1
DEFAULT_FEATURES_STATE := 1
DEFAULT_GESTURES_STATE := 1
DEFAULT_AUTOUPDATE := 1

MAIN_DEFAULT_HOTKEY := "#Z"
CLIPX_DEFAULT_HOTKEY := "#X"
MEMOS_DEFAULT_HOTKEY := "#A"
WIN_HIDE_DEFAULT_HOTKEY := "#C"
HIDE_WINDOW_DEFAULT_HOTKEY := ""
DEFAULT_RECENT_HOTKEY := "#Q"

MAIN_DEFAULT_GESTURE := "D"
CLIPX_DEFAULT_GESTURE := "U"
WIN_HIDE_DEFAULT_GESTURE := "R"
MEMOS_DEFAULT_GESTURE := "L"
RECENT_DEFAULT_GESTURE := "UR"

UpdateGestureButton()
HotkeysGlobalState := OptGet("HotkeysGlobalState")
if HotkeysGlobalState not in 0,1
	HotkeysGlobalState := 1
GesturesGlobalState := OptGet("GesturesGlobalState")
if GesturesGlobalState not in 0,1
	GesturesGlobalState := 1

Global_Gesture_Disable_Time := OptGet("Gesture_Disable_Time")
if (Global_Gesture_Disable_Time = "ERROR" or Global_Gesture_Disable_Time = "")
	Global_Gesture_Disable_Time := 10000 ; 10 Seconds

DEFAULT_TRANSP_LEVEL := 150
DEFAULT_FADE := 1

CHANGELOG_URL := "http://apathysoftworks.com/QC/qc_update/changelog.txt"
CHANGELOG_TEMP_PATH = %A_Temp%\changelog.txt
LAST_VER_URL := "http://apathysoftworks.com/QC/qc_update/last_ver.txt" 		;download url for file with latest version
LAST_VER_PATH = %A_Temp%\app_last_ver.txt 						;where file with latest version will be placed after download
UPDATER_URL := "http://apathysoftworks.com/QC/qc_update/QC_updater.exe" 		;download url for updater
UPDATER_PATH = %A_Temp%\QC_updater.exe 							;where updater will be downloaded to

/*
Used gui numbers:
1 - main gui,
2 - options,
3 - ChangeDefaultHotkeys
4 - add shortcut,
5 - add mail,
6 - about
7 - help gui
8 - for On-Top-Memos
9 - for Custom Hotkeys gui
10 - Custom Hotkeys Edit Hotkey
11 - GetPassword GUI
12 - props gui
20 - for FeedBack
21 - Send new Afo
22 - view clip
23 - System Shortcut Gui
24 - Win Transparency
25 - 
26 - Item Edit
27 - Special Targets description
29 - change log
30-98 - used for memo-on-top
99 -  used by mmenu

Splashes:
2 - for copyto command
3 - update check
5 - feedback delivering
7 - common

IMPORTANT GLOBAL VARS:
DeleteNotificationState - indicates if delete notification is already enabled for recent processes logging or not
icons_ext_handles - handles for icons got through
brushes_handles - handles for mmenu brushes
global_IconsOnly - 1 if option to show icons only in menu enabled
*/