﻿SetHotkeys()
{
	global ClipXEnabled, Memos_On, Win_Hide_Enabled, Recent_On, CustomHotkeys_ActivateList
	global MAIN_DEFAULT_HOTKEY, CLIPX_DEFAULT_HOTKEY, MEMOS_DEFAULT_HOTKEY, WIN_HIDE_DEFAULT_HOTKEY, DEFAULT_RECENT_HOTKEY
	global cur_clips_copy_hk, cur_clips_append_hk, cur_clips_paste_hk
	
	hk_error := 0
	hk_error_descr := ""
	
	err := Hotkey(hk := GetMainHotkey(),1,"OpenMenu")
	if err
	{
		hk_error := 1
		hk_error_descr .= "`nWrong hotkey: " . HotkeyToString(hk) . " for Main Menu.`n" err
		err := Hotkey(MAIN_DEFAULT_HOTKEY,1,"OpenMenu")
		if !err
			hk_error_descr .= "`nWas replaced by " . HotkeyToString(MAIN_DEFAULT_HOTKEY)
	}
	
	if Memos_On
	{
		err := Hotkey(hk := GetMemosHotkey(),1,"ShowMemos")
		if err
		{
			hk_error := 1
			hk_error_descr .= "`nWrong hotkey: " . HotkeyToString(hk) . " for Memos Menu.`n" err
			err := Hotkey(MEMOS_DEFAULT_HOTKEY,1,"ShowMemos")
			if !err
				hk_error_descr .= "`nWas replaced by " . HotkeyToString(MEMOS_DEFAULT_HOTKEY)
		}
	}

	if ClipXEnabled
	{
		#UseHook
		loop_hk_error := 0
		Loop, 9
		{
			if (cur_clips_copy_hk != "")	{
				if Hotkey(cur_clips_copy_hk A_Index,1,"ChangeClips")
					loop_hk_error := 1
			}
			if (cur_clips_append_hk != "")	{
				if Hotkey(cur_clips_append_hk A_Index,1,"ChangeClips")
					loop_hk_error := 1
			}
			if (cur_clips_paste_hk != "")	{
				if Hotkey(cur_clips_paste_hk A_Index,1,"ChangeClips")
					loop_hk_error := 1
			}
		}
		if loop_hk_error
		{
			hk_error_descr .= "`nError occured on hotkeys setting up for clips"
			hk_error := 1
		}
		err := Hotkey(hk := GetClipsHotkey(),1,"ShowClipsMenu")
		if err
		{
			hk_error := 1
			hk_error_descr .= "`nWrong hotkey: " . HotkeyToString(hk) . " for Clips Menu.`n" err
			err := Hotkey(CLIPX_DEFAULT_HOTKEY,1,"ShowClipsMenu")
			if !err
				hk_error_descr .= "`nWas replaced by " . HotkeyToString(CLIPX_DEFAULT_HOTKEY)
		}
		#UseHook OFF
	}
	
	if Win_Hide_Enabled
	{
		hk := GetHideAWindowHotkey(1)
		if InStr(hk,"Space")
			err := Hotkey(hk,1,"Win_Hotkey_Ex")
		else
		{
			err := Hotkey("^Space",0,"Win_Hotkey_Ex")
			if (hk != "")
				err := Hotkey(hk,1,"Win_Hotkey_Ex")
		}
		if err
		{
			hk_error := 1
			hk_error_descr .= "`nWrong hotkey: " . HotkeyToString(hk) . " for Hide Active Window.`n" err
			err := Hotkey("^Space",1,"Win_Hotkey_Ex")
			if !err
				hk_error_descr .= "`nWas replaced by " . HotkeyToString("^Space")
		}
		err := Hotkey(hk := GetWindowsHotkey(),1,"ShowWinHideMenu")
		if err
		{
			hk_error := 1
			hk_error_descr .= "`nWrong hotkey: " . HotkeyToString(hk) . " for Windows Menu.`n" err
			err := Hotkey(WIN_HIDE_DEFAULT_HOTKEY,1,"ShowWinHideMenu")
			if !err
				hk_error_descr .= "`nWas replaced by " . HotkeyToString(WIN_HIDE_DEFAULT_HOTKEY)
		}
	}
		
	if Recent_On
	{
		err := Hotkey(hk := GetRecentHotkey(),1,"ShowRecent")
		if err
		{
			hk_error := 1
			hk_error_descr .= "`nWrong hotkey: " . HotkeyToString(hk) . " for Recent Menu.`n" err
			err := Hotkey(DEFAULT_RECENT_HOTKEY,1,"ShowRecent")
			if !err
				hk_error_descr .= "`nWas replaced by " . HotkeyToString(DEFAULT_RECENT_HOTKEY)
		}		
	}


	ctrl_rb := OptGet("DefaultHotkey_ctrl_rb")
	err := Hotkey(hk := "^RButton",ctrl_rb,"OpenMenu")
	if err
	{
		hk_error := 1
		hk_error_descr .= "`nHotkey wasn't set: " . HotkeyToString(hk) "`nError:`n" err
	}
	ctrl_mb := OptGet("DefaultHotkey_ctrl_mb")
	err := Hotkey(hk := "^MButton",ctrl_mb,"OpenMenu")
	if err
	{
		hk_error := 1
		hk_error_descr .= "`nHotkey wasn't set: " . HotkeyToString(hk) "`nError:`n" err
	}
	lb_rb := OptGet("DefaultHotkey_lb_rb")
	err := Hotkey(hk := "~LButton & RButton",lb_rb,"OpenMenu")
	if err
	{
		hk_error := 1
		hk_error_descr .= "`nHotkey wasn't set: " . HotkeyToString(hk) "`nError:`n" err
	}

	SetCustomHotkeys(CustomHotkeys_ActivateList,1)

	if hk_error
		MsgBox,4096,Some hotkeys waren't set,% "The following hotkeys waren't set due the error:`n" . hk_error_descr . "`n`nIf you don't know what the problem may be, please copy the content of this message and send us as a bug on support@apathysoftworks.com"

	return 1
}

SuspendHotkeys(state)
{
	global NO_GESTURES
	global DEFAULT_FEATURES_STATE
	global CLIPX_DEFAULT_GESTURE, MAIN_DEFAULT_GESTURE, WIN_HIDE_DEFAULT_GESTURE, MEMOS_DEFAULT_GESTURE
	global CLIPX_DEFAULT_HOTKEY, MAIN_DEFAULT_HOTKEY, WIN_HIDE_DEFAULT_HOTKEY, HIDE_WINDOW_DEFAULT_HOTKEY, MEMOS_DEFAULT_HOTKEY	
	global CustomHotkeys_ActivateList
	global cur_clips_copy_hk, cur_clips_append_hk, cur_clips_paste_hk
	
	if state not in ON,OFF
		return
	state := state = "ON" ? 1 : 0

	ClipXEnabled := OptGet("ClipXEnabled")
	if ClipXEnabled not in 0,1
		ClipXEnabled := DEFAULT_FEATURES_STATE
	Win_Hide_Enabled := OptGet("Win_Hide_Enabled")
	if Win_Hide_Enabled not in 0,1
		Win_Hide_Enabled := DEFAULT_FEATURES_STATE
	Memos_On := OptGet("Memos_On")
	if Memos_On not in 0,1
		Memos_On := DEFAULT_FEATURES_STATE
	Recent_On := GetRecentState()
	
	if (Win_Hide_Enabled = 1)
	{
		WH_UseCSpace := OptGet("WH_UseCSpace")
		if WH_UseCSpace not in 0,1
			WH_UseCSpace := 1
		Hide_OptionalHotkey := OptGet("Hide_OptionalHotkey")
		if (Hide_OptionalHotkey == "ERROR" || Hide_OptionalHotkey == "")
			Hide_OptionalHotkey := HIDE_WINDOW_DEFAULT_HOTKEY	
		Win_Hide_Show_Hotkey := OptGet("Win_Hide_Show_Hotkey")
		if (Win_Hide_Show_Hotkey == "ERROR" || Win_Hide_Show_Hotkey == "")
			Win_Hide_Show_Hotkey := WIN_HIDE_DEFAULT_HOTKEY
		if (WH_UseCSpace = 1)
			Hotkey("^Space",state)
		else
			Hotkey(Hide_OptionalHotkey,state)
		Hotkey(Win_Hide_Show_Hotkey,state)
	}

	if (ClipXEnabled = 1)
	{
		ClipXHotkey := OptGet("ClipXHotkey")
		if (ClipXHotkey = "ERROR" || ClipXHotkey = "")
			ClipXHotkey:= CLIPX_DEFAULT_HOTKEY
		Hotkey(ClipXHotkey,state)
		#UseHook
		Loop, 9
			{
				if (cur_clips_copy_hk != "")
					Hotkey(cur_clips_copy_hk A_Index,state)
				if (cur_clips_append_hk != "")
					Hotkey(cur_clips_append_hk A_Index,state)
				if (cur_clips_paste_hk != "")
					Hotkey(cur_clips_paste_hk A_Index,state)
			}	
		#UseHook OFF
	}


	if (Memos_on = 1)
	{
		Memos_hotkey := OptGet("Memos_hotkey")
		if (Memos_hotkey = "ERROR" || Memos_hotkey = "")
			Memos_hotkey := MEMOS_DEFAULT_HOTKEY
		Hotkey(Memos_hotkey,state)
	}
	
	if (Recent_On = 1)
		Hotkey(GetRecentHotkey(),state)
	
	ctrl_rb := OptGet("DefaultHotkey_ctrl_rb")
	if (ctrl_rb = 1)
		Hotkey("^RButton",state)

	ctrl_mb := OptGet("DefaultHotkey_ctrl_mb")
	if (ctrl_mb = 1)
		Hotkey("^MButton",state)
		
	lb_rb := OptGet("DefaultHotkey_lb_rb")
	if (lb_rb = 1)
		Hotkey("~LButton & RButton",state)

	SetCustomHotkeys(CustomHotkeys_ActivateList,state = "ON" ? 1 : 0)

	return
}

; ifWin = 1 for IfWinActive, 0 for IfWinNotActive
Hotkey(hkey,state,label="",IfWin="",title="")
{
	if (hkey = "")
		return
	if state not in 0,1
		return
	hk_list := HotkeyGetVK(hkey)
	if IfWin in 0,1
	{
		SetTitleMatchMode, RegEx
		Hotkey,% "IfWin" (IfWin ? "Active" : "NotActive"),% title
	}
	if hk_list.MaxIndex()
		for i,hk in hk_list
		{
			HotKey,% hk,% label,% (state = 0 ? "OFF" : "ON") " UseErrorLevel"
			if ErrorLevel
				error .= (error ? "`n" : "") "Error: " . ErrorLevel . "; Hotkey wasn't set: " . HotkeyToString(hkey) . "; Code: " . hk
		}
	else
		error .= (error ? "`n" : "") "Hotkey wasn't set: " . HotkeyToString(hkey) . "; The required symbol was not found on your current keyboard layouts."
	if IfWin in 0,1
		Hotkey,IfWinActive
	return error
}

; this code disables/enables gesture button if specified windows is active
SetGestureGuiMatch(gestureState)
{
	global GlobalGestureButton
	global PROPS_GUI_TITLE, SYS_GUI_TITLE, MEMOS_TITLE, MB_NAME
	SetTitleMatchMode RegEx
	Hotkey, IfWinNotActive, i)^\s*(%PROPS_GUI_TITLE%|%SYS_GUI_TITLE%|%MEMOS_TITLE%|%MB_NAME%)\s*$
		if gestureState in 0,1
			Hotkey, %GlobalGestureButton%, GesturesSub,% (gestureState ? "ON" : "OFF") " UseErrorLevel" ;mouse gestures
		else if (gestureState = -1)
		{
			Hotkey, RButton, OFF,UseErrorLevel		;Should turn off all gestures to prevent both being on
			Hotkey, MButton, OFF, UseErrorLevel
			Hotkey, XButton1, OFF, UseErrorLevel
			Hotkey, XButton2, OFF, UseErrorLevel
		}
	Hotkey, IfWinActive
	return
}

UpdateGestureButton()
{
	global
	SetGestureGuiMatch(-1)
	GlobalGestureButton := OptGet("GlobalGestureButton")
	If GlobalGestureButton not in RButton,MButton,XButton1,XButton2
		GlobalGestureButton := "RButton"
	return
}

