﻿;###########################################################
RGBtoBGR(color)
{
	last_byte := SubStr(color, 5)
	StringTrimRight, color, color, 2
	first_byte := SubStr(color, 1, 2)
	StringTrimLeft, color, color, 2
	color := last_byte . color . first_byte
	return color
}
;###########################################################
;Main function for rebuilding menus
MenuRebuild(MName,Mcol="",Tcol="", initial=1)	
{
	
	global
	local order, MColor, TColor, IName, Bold, sub, iIcon, itemNum, div
	local ItemDIsabled, iHotkey, next_item_ID, df_m, icopath, icoindex
	local target, OutFileName, OutDir, OutExtension, OutNameNoExt, OutDrive
	if initial
	{
		CustomHotkeysList =
		df_targets := df_built_menus := df_menus := df_targets_count := ""	;Folder Menu related vars
		HotKeysAllowed = 0
		global_LightMenu := GetLightMenuState()
		IsLogRunningShortcuts := GetRecentLogShortcuts()
		SetCustomHotkeys(CustomHotkeys_ActivateList,0) ;disabling all custom hotkeys
		CustomHotkeys_ActivateList =
		ItemsHeight_adj := GetItemsHeight()
		global_Icons_Size := GetIconSize()
		global_IconsOnly := global_LightMenu ? 0 : GetOptIconsOnly()
		global_ShowTooltip := global_IconsOnly ? GetOptShowTlp() : 0
		global_UseColumns := GetOptUseColumns()
		if global_UseColumns
		{
			global_MaxPerCol := GetOptMaxPerColumn()
			global_ColBarBreak := GetOptBarBreak()
		}
		DF_FreeBrushes()
	}
	
	MMenu_Remove(QC_MMenus[MName],"Recent_menu") ;removing Recent Menu to avoid data loss
	MMenu_Destroy(QC_MMenus[MName])
;~ 	######### getting colors
	MColor := GetMenuColor(MName,"MenuColor",Mcol)
	TColor := GetMenuColor(MName,"TextColor",Tcol)
;~ 	##################
	QC_MMenus[MName] := MMenu_Create("S" . global_Icons_Size . " C" . MColor . " O" . ICON_OFFSET . " T" . TColor . " I" . ItemsHeight_adj,global_LightMenu)
	order := 0
	itemNum := 0
	Loop
	{
		IName := ItemGet(order,MName)
		if (IName == "ERROR")
			break
;~ 	######### ICON
		iIcon := ItemGet(order . "#ICON",MName)
		if (iIcon == "ERROR")
			iIcon := ""
;~ 	######### HOTKEY
		iHotkey := ItemGet(order . "#HOTKEY",MName)
		if (iHotkey = "ERROR")
			iHotkey := 0
;~ 	##################	
		
		IfInString, IName, #B# ; if bold
		{
			StringReplace, IName, IName, #B# 
			Bold := "d"
		}
		else
			Bold := ""
		IfInString, IName, #M# ;if submenu
		{
			StringReplace, IName, IName, #M#
			sub := " m" . MenuRebuild(MName . "#" . GetItemId(IName),MColor,TColor,0)
		}
		else
			sub := ""
		next_item_ID := GetItemId(MName . "#" . IName)
		if (substr(IName,0) = "*")
		{
			df_m := MMenu_Create("S" . global_Icons_Size)
			df_menus .= "`n" . df_m . "|" . DF_GetTarget(next_item_ID)
			next_item_ID := "DF_" . next_item_ID
			MMenu_Add(df_m, "- :Open Folder: -",DF_OPEN_FOLDER . "_DF","","iDF_DFM_" . df_m)
			sub := " m" . df_m
		}
		;hotkey definition
		if iHotkey
		{
			if sub			
			{
				StringTrimLeft,menu_num,sub,2		;getting menu number from "sub" var
				CustomHotkeysList := CustomHotkeysList . iHotkey . "#HK#" . order . "#ORD#" . MName . "#ST#" . menu_num . "#NM#" . IName . "`n"
			}
			else
				CustomHotkeysList := CustomHotkeysList . iHotkey . "#HK#" . order . "#ORD#" . MName . "#ST#" . next_item_ID  . "`n"
			CustomHotkeys_ActivateList := CustomHotkeys_ActivateList . iHotkey . "`n"
		}
		
		if iIcon
		{
			icoindex := IconGetIndex(iIcon)
			icopath := IconGetPath(iIcon)
			iIcon := icopath . (icoindex != "" ? (":" . icoindex) : "")
		}
		
		div := ColDiv(itemNum)
		
		If RegExMatch(IName,"^#[0-9]*$")
		{
			if div
				itemNum := global_MaxPerCol
			else
				MMenu_Add(QC_MMenus[MName])
		}
		Else
		{
			MMenu_Add(QC_MMenus[MName], IName,iIcon,"",Bold . " i" . next_item_ID . sub . div,global_IconsOnly)
			itemNum++
		}
		order++
	}
;########### MAIN ####################
	if (MName == MAIN_SECTION_NAME)
	{
		Menu,tray, DeleteAll
		Menu, tray, NoStandard

		HideAddChange := OptGet("HideAddChange")
		
		ClipXEnabled := GetClipsState()
		Win_Hide_Enabled := GetWindowsState()
		Memos_On := GetMemosState()
		Recent_On := GetRecentState()
		
		global_itemNum := itemNum
		AddExtras(QC_MMenus[MName],MColor,TColor,GetIconSize())
		itemNum := global_itemNum
		global_itemNum =
		
		if !GetHelpItemState()
		{
			div := ColDiv(itemNum)
			if !div
				MMenu_Add(QC_MMenus[MName])
			local separ_added := 1
			MMenu_Add(QC_MMenus[MName], "Quick Help", HELP_ICO,"","iQuickHelp" . div,global_IconsOnly)
			itemNum++
		}
		
		SuspendMenuHandle := MMenu_Create("S" . GetIconSize() . " C" . MColor . " O" . ICON_OFFSET . " T" . TColor,global_LightMenu)
		MMenu_Add(SuspendMenuHandle, isSuspended := HotkeysGlobalState = 1 ? "Hotkeys ON" : "Hotkeys OFF", ico := HotkeysGlobalState = 1 ? SUSPEND_ON_ICO : SUSPEND_OFF_ICO,"","iHK_Susp")
		MMenu_Add(SuspendMenuHandle, GesturesState := GesturesGlobalState = 1 ? "Gestures ON" : "Gestures OFF", ico := GesturesGlobalState = 1 ? SUSPEND_ON_ICO : SUSPEND_OFF_ICO,"","iGS_Susp")
		
		if !GetSuspendItemState()
		{
			div := ColDiv(itemNum)
			if (!separ_added && !div)
				MMenu_Add(QC_MMenus[MName])
			MMenu_Add(QC_MMenus[MName], "Suspend", SUSPEND_ICO,"","iSusp m" . SuspendMenuHandle . div,global_IconsOnly)
			itemNum++
		}
		
		if (HideAddChange != 1) ; OR IsTrayHidden = 1)
		{
			div := ColDiv(itemNum)
			if !div
				MMenu_Add(QC_MMenus[MName])
			MMenu_Add(QC_MMenus[MName], "Add/Change", ADD_CHANGE_ICO,"","i" . GetItemId(MName . "#AddChange") . div,global_IconsOnly)
			itemNum++
		}

		isChecked =
		;############ TRAY MENU ###################
		HotKeySq := HotkeyToString(GetMainHotkey())
		Menu,tray, add,%MB_NAME% welcomes you!,ADDMENUGUI
		Menu,tray, add
		Menu,tray, add,Use %HotKeySq% to open menu, OpenMenu
		Menu,tray,Default,%MB_NAME% welcomes you!
		Menu,tray, add
		Menu,tray, add,Add/Change, ADDMENUGUI
		Menu,tray, add
		Menu,tray, add,% HotkeysGlobalState = 1 ? "Hotkeys ON" : "Hotkeys OFF",HotkeysSuspend
		Menu,tray, add,% GesturesGlobalState = 1 ? "Gestures ON" : "Gestures OFF",GesturesSuspend
		Menu,tray, add
		Menu,tray, add,Exit
;###############################
	}
	if initial ;hotkeys settings
	{
		DisableClipXHotkeys()								;disabling old clips hotkeys
		
		cur_clips_copy_hk := Clips_GetCopyHK()				;this is global vars containing hotkeys for clips functional
		cur_clips_append_hk := Clips_GetAppendHK()
		cur_clips_paste_hk := Clips_GetPasteHK()
		
		SetHotkeys()
		HotKeysAllowed = 1
		
		if (HotkeysGlobalState = 0)
			SuspendHotkeys("OFF")
			
		;Gestures ini values read... taken from gestures sub because ini reads were delaying the show menu
		MainGesture := GetMainGesture()
		ClipXGesture := GetClipsGesture()
		WinHideGesture := GetWindowsGesture()
		Memos_Gesture := GetMemosGesture()
		GS_Recent_Gesture := GetRecentGesture()
		
		Gesture_Clipx_enabled := OptGet("Gesture_Clipx_enabled")
			if Gesture_Clipx_enabled not in 0,1
				Gesture_Clipx_enabled := DEFAULT_GESTURES_STATE	
		Gesture_Main_enabled := OptGet("Gesture_Main_enabled")
			if Gesture_Main_enabled not in 0,1
				Gesture_Main_enabled := DEFAULT_GESTURES_STATE
		Gesture_WH_enabled := OptGet("Gesture_WH_enabled")
			if Gesture_WH_enabled not in 0,1
				Gesture_WH_enabled := DEFAULT_GESTURES_STATE
		Gesture_Memos_enabled := OptGet("Gesture_Memos_enabled")
			if Gesture_Memos_enabled not in 0,1
				Gesture_Memos_enabled := DEFAULT_GESTURES_STATE
		Gesture_Recent_enabled := GetRecentGestureState()
		
		UpdateGestureButton()
			
		if (Gesture_Clipx_enabled=0 && Gesture_Main_enabled=0 && Gesture_WH_enabled=0 && Gesture_Memos_enabled=0 && Gesture_Recent_enabled=0)
		{
			MMenu_Set(SuspendMenuHandle, "GS_Susp", "Gestures OFF", " ","g")
			Menu,tray,Rename,% GesturesState := GesturesGlobalState = 1 ? "Gestures ON" : "Gestures OFF",% "Gestures OFF"
			Menu,tray,Disable,% "Gestures OFF"
		}
		else if (GesturesGlobalState = 1)
			SetGestureGuiMatch(1)
		ItemsHeight_adj = 
	}
	return QC_MMenus[MName]
}

GetMenuColor(menu_name,key,parent_menu_color="",smenu_ini = "")
{
	global MENU_COLOR_DEFAULT,TEXT_COLOR_DEFAULT
	def_color := key = "MenuColor" ? MENU_COLOR_DEFAULT : key = "TextColor" ? TEXT_COLOR_DEFAULT : "000000"
	col := ItemGet(key,menu_name,smenu_ini)
	if (parent_menu_color != "" AND (col = "ERROR" || col = ""))
		col := parent_menu_color
	else if (col != "ERROR" && col != "")
		col := RGBtoBGR(col)
	else if (col = "ERROR" || col = "")
		col := RGBtoBGR(def_color)
	if col Contains 0x
		StringReplace, col, col, 0x
	if col is not Xdigit
		col := RGBtoBGR(def_color)
	col := StrLen(col) > 6 ? RGBtoBGR(def_color) : col	
	return col
}

ColDiv(ByRef iNum,ChangeNum = 1)
{
	global
	local div
	if (global_UseColumns && iNum >= global_MaxPerCol)
	{
		div := " b" . (global_ColBarBreak ? "|" : "")
		if ChangeNum
			iNum := 0
	}
	else
		div =
	return div
}