﻿;#################### BUILDTREE #######################################
BuildTree(PID,MName,FullRecreate = 0)
{
	local order, MColor, TColor, IName, Bold, sub, iIcon, SubID
	Gui, 1:Default
	if FullRecreate
	{
		TV_Delete()
		GuiControl, -Redraw, AnTreeView
		TV_IL := new MIL()
		SendMessage( TV_hwnd, 0x1100 + 9, 0, TV_IL.hSmall )			; TVM_SETIMAGELIST = 0x1100 + 9
		SplashWait(1,"Please Wait`nBuilding the menu...",1,0)
	}
	order := 0
	Loop
	{
		IName := ItemGet(order,MName)
		if (IName == "ERROR")
			break
		iIcon := ItemGet(order . "#ICON",MName)
		if (iIcon == "ERROR" || iIcon == "")
			iIcon := NO_ICO_NUM			;specify non existent icon. Can make a menu with one million items, huh?
		Else {
			if !iIcon := TV_IL.Add( IconGetPath(iIcon), IconGetIndex(iIcon)+1)
				iIcon := NO_ICO_NUM
		}
		IfInString, IName, #B#
		{
			StringReplace, IName, IName, #B#
			Bold := " Bold "
		}
		else
			Bold := ""
		IfInString, IName, #M#
		{
			StringReplace, IName, IName, #M#
			sub := 1
		}
		else
			sub := 0
		If RegExMatch(IName,"^#[0-9]*$")
		{
			StringReplace, IName, IName, #, %SEPARATOR_STRING%
			TV_Add(IName,PID," Icon" . iIcon)
		}
		Else
			SubID := TV_Add(IName,PID,Bold . " Icon" . iIcon)
		if (sub == 1)
			BuildTree(SubID,MName . "#" . GetItemID(IName)) ;,CurMenu_BKclr,CurMenu_Tclr)
		order++
	}
	if FullRecreate
	{
		TV_ArrangeColors()
		SetTreeColors()
		GuiControl, +Redraw, AnTreeView
		TV_Redraw()
		SplashWait(0)
	}
	return
}

TV_ArrangeColors(menuID=0,updateTV=0)
{
	global TV_MCLR, MENU_COLOR_DEFAULT, TEXT_COLOR_DEFAULT
	static M_IDs
	if (menuID==0)	;full menu recalculate
	{
		if IsObject(M_IDs)
			for i,val in M_IDs
				TV_MCLR.Remove[val,""]
		M_IDs := array()
		TV_MCLR := object()
		TV_MCLR[-1,"tc"] := "0x" . RGBtoBGR(TEXT_COLOR_DEFAULT)		;used for default colors when enabled options "Use Default List Colors"
		TV_MCLR[-1,"bgc"] := "0x" . RGBtoBGR(MENU_COLOR_DEFAULT)
	}
	Gui, 1:Default
	if itemID := TV_GetChild(menuID)
	{
		tc := MenuGetColor("t",menuID,1)
		bgc := MenuGetColor("bg",menuID,1)
		TV_MCLR[menuID,"tc"] := tc="" ? TV_MCLR[TV_GetParent(menuID),"tc"] : ("0x" . RGBtoBGR(tc))
		TV_MCLR[menuID,"bgc"] := bgc="" ? TV_MCLR[TV_GetParent(menuID),"bgc"] : ("0x" . RGBtoBGR(bgc))
		M_IDs.insert(menuID)
	}
	else
		return
	loop
	{
		if TV_GetChild(itemID)
			TV_ArrangeColors(itemID)
		itemID := TV_GetNext(ItemID)
		if !itemID
			break
	}
	if updateTV
		TV_Redraw()
	return
	
	
}

TV_Redraw()
{
	SetTimer,TV_Redraw,-200
	return
	
	TV_Redraw:
		Gui, 1:Default
		GuiControl, MoveDraw, AnTreeView
		return
}

class MIL
{
	__New()
	{
		this.hSmall := IL_Create(20,10,0)
		this.hBig := IL_Create(20,10,1)
	}
	
	__Delete()
	{
		IL_Destroy(this.hSmall)
		IL_Destroy(this.hBig)
	}
	
	Get(ind,size=1)
	{
		if (size = 0)
			hIcon := IL_GetIcon(this.hSmall,ind)
		else
			hIcon := IL_GetIcon(this.hBig,ind)
		return hIcon
	}
	
	Add(path,num)
	{
		if index := IL_Add(this.hSmall,path,num)
			IL_Add(this.hBig,path,num)
		return index
	}
	
	AddH(hIcon,ind=-1)
	{
		ret_ind := IL_AddIcon(this.hSmall,hIcon,ind)
		IL_AddIcon(this.hBig,hIcon,ind)
		return ret_ind
	}
}	

MG_TV_CustomDraw(hNMTVCUSTOMDRAW)
{
	global TV_MCLR,MENU_COLOR_DEFAULT,TEXT_COLOR_DEFAULT
	global global_tvDefColors
	tvcd := hNMTVCUSTOMDRAW
;~ typedef struct tagNMTVCUSTOMDRAW {

  ;~ NMHDR     hdr;					0
  ;~ DWORD     dwDrawStage;			3ptr
  ;~ HDC       hdc;					4ptr
  ;~ RECT      rc;					5ptr
  ;~ DWORD_PTR dwItemSpec;			16+5ptr
  ;~ UINT      uItemState;			16+6ptr
  ;~ LPARAM    lItemlParam;			16+7ptr

  ;~ COLORREF     clrText;			16+8ptr
  ;~ COLORREF     clrTextBk;		20+8ptr
;~ #if (_WIN32_IE >= 0x0400)
  ;~ int          iLevel;			24+8ptr
;~ #endif 
;~ } NMTVCUSTOMDRAW, *LPNMTVCUSTOMDRAW;
	hdc := NumGet(tvcd+0, 4*A_PtrSize, "UPtr")
	dstage := NumGet(tvcd+0, 3*A_PtrSize, "UInt")
	itemID := NumGet(tvcd+0,5*A_PtrSize+16,"UPtr")
	itemState := NumGet(tvcd+0,6*A_PtrSize+16,"UInt")

	if (dstage = 0x00000001)
		return 0x00000020
	;~ if (dstage != 0x10001)
		;~ return 0
	
	if ((itemState & 0x0001) = 0x0001)	;sets the color of selection line
	{
		NumPut(0x906A1A,tvcd+0,8*A_PtrSize+16,"UInt")
		NumPut(0xFFFFFF,tvcd+0,8*A_PtrSize+20,"UInt")
		rc := tvcd+5*A_PtrSize
		hBrush := GetBrushHandle( 0xFFFFFF )
		DllCall("FillRect", "Ptr", hdc, "Ptr", rc, "Ptr", hBrush)
	}
	else
	{
		pid := TV_GetParent(itemID)
		;pid := TV_GetChild(itemID) ? itemID : TV_GetParent(itemID)	;this line determine if menu item is of the same color as it's childs
		tc := global_tvDefColors ? TV_MCLR[-1,"tc"] : TV_MCLR[pid,"tc"]
		bgc := global_tvDefColors ? TV_MCLR[-1,"bgc"] : TV_MCLR[pid,"bgc"]
		NumPut(tc,tvcd+0,8*A_PtrSize+16,"UInt")
		NumPut(bgc,tvcd+0,8*A_PtrSize+20,"UInt")
		rc := tvcd+5*A_PtrSize
		hBrush := GetBrushHandle( bgc )
		DllCall("FillRect", "Ptr", hdc, "Ptr", rc, "Ptr", hBrush)
	}
	return 0
}