﻿;######### Main FUnctions for ini operation
;options sets
OptSet(name,val)
{
	global SETSNAME
	if (name = "")
		return
	IniWrite,% val,% SETSNAME, Options,% name
	if ErrorLevel
		IniError()
	return val
}

OptGet(name)
{
	global SETSNAME
	if (name = "")
		return
	IniRead, val,% SETSNAME, Options,% name
	return val
}

OptDel(name)
{
	global SETSNAME
	if (name = "")
		return
	IniDelete,% SETSNAME, Options,% name
	return
}

;items sets
ItemSet(name,sect,val,ini="")
{
	global MENUITEMSINI
	if (name = "" || sect = "")
		return
	IfExist,% ini
		IniWrite,% val,% ini,% sect,% name
	else
	{
		val := GetRelative( name, sect, val )
		IniWrite,% val,% MENUITEMSINI,% sect,% name
	}
	if ErrorLevel
		IniError()
	return val
}

GetRelative( name, sect, val )
{
	global MULTI_TARGET_DIVIDER, opt
	if ( opt[ "IconRelativePath" ] && RegExMatch( trim( name ), "^[0-9]+#ICON$" ) )
		val := IconGetRelative( val )
	if ( sect = "Targets" && opt[ "CmdRelativePath" ] )
	{
		tm := val
		val := ""
		def = ^"".*?""$
		repln = ^""|""$
		repl = "
		if RegExMatch( tm, def )
		{
			dquotes := 1
			tm := RegExReplace( tm, repln, repl )
		}
		for i,v in StrSplit( tm, MULTI_TARGET_DIVIDER, A_Tab A_Space )
			val .= ( val ? MULTI_TARGET_DIVIDER : "" ) QCPathMakeRelative( v )
		if dquotes
			val = "%val%"
	}
	return val
}

ItemGet(name,sect,ini="")
{
	global MENUITEMSINI
	if (name = "" || sect = "")
		return
	IfExist,% ini
		IniRead, val,% ini,% sect,% name
	else
		IniRead, val,% MENUITEMSINI,% sect,% name
	return val
}

ItemDel(name,sect,ini="")
{
	global MENUITEMSINI
	if (name = "" || sect = "")
		return
	IfExist,% ini
		IniDelete,% ini,% sect,% name
	else
		IniDelete,% MENUITEMSINI,% sect,% name
	if ErrorLevel
		IniError()
	return
}

ItemSecDel(sect,ini="")
{
	global MENUITEMSINI
	if (sect = "")
		return
	IfExist,% ini
		IniDelete,% ini,% sect
	else
		IniDelete,% MENUITEMSINI,% sect
	if ErrorLevel
		IniError()
	return
}

IniError()
{
	global Exit_NoNotify
	static ignore_errors
	if ignore_errors
		return
	msg = 
	(LTrim
	Could not write to Quick Cliq's settings ini file.
	The required file is probably in a write restricted folder or blocked by another program.

	Press Cancel to skip future error checks, however Quick Cliq may not work correctly if this is set.
	Do you want to try and start Quick Cliq under administrative rights?
	)
	MsgBox,4115,Ini Reading Error,% msg
	IfMsgBox,Yes
	{
		API_ShellExecute(A_ScriptFullPath,"-admintry", A_ScriptDir,"RUNAS")
		Exit_NoNotify = 1
		ExitApp
	}
	IfMsgBox,Cancel
		ignore_errors = 1
	return
}
;######### MENU TRANSPARENT
GetMenusTrans() {
	trans := OptGet("menus_transparency")
	if trans not Between 0 and 255
		trans := 255
	return trans
}

SetMenusTrans(trans) {
	global MM_TRANSPARENCY
	if trans not Between 0 and 255
		return 0
	OptSet("menus_transparency",trans)
	MM_TRANSPARENCY := trans
	return 1
}
;######### MULTI-TARGET DELAY
GetMultiDelay() {
	global DEFAULT_MULTI_TARGET_DELAY
	dl := OptGet("MiltiDelay")
	if dl not between 0 and 10000
		dl := DEFAULT_MULTI_TARGET_DELAY
	return dl
}

SetMultiDelay(new_delay) {
	OptSet("MiltiDelay",new_delay)
	return
}

;######### RECENT FEATURE
;--------- GESTURE STATE
GetRecentGestureState()	{
	global DEFAULT_GESTURES_STATE
	gs := OptGet("Recent_Gesture_State")
	if gs not in 0,1
		gs := DEFAULT_GESTURES_STATE
	return gs
}

SetRecentGestureState(new_state) {
	OptSet("Recent_Gesture_State",new_state)
	return new_state
}
;--------- GESTURE
GetRecentGesture() {
	global RECENT_DEFAULT_GESTURE
	gs := OptGet("Recent_Gesture")
	if RegExMatch(gs,"[^RLUD]")
		gs := RECENT_DEFAULT_GESTURE
	return gs	
}

SetRecentGesture(new_gesture) {
	OptSet("Recent_Gesture",new_gesture)
	return new_gesture
}
;--------- RECENT STATE
GetRecentState() {
	global DEFAULT_FEATURES_STATE
	st := OptGet("Recent_State")
	if st not in 0,1
		st := DEFAULT_FEATURES_STATE
	return st
}

SetRecentState(new_state) {
	OptSet("Recent_State",new_state)
	return new_state
}
;--------- RECENT SHOW IN MAIN MENU STATE
GetRecentSubState()	{
	global DEFAULT_SHOW_IN_MAIN
	st := OptGet("Recent_Sub_State")
	if st not in 0,1
		st := DEFAULT_SHOW_IN_MAIN
	return st	
}

SetRecentSubState(new_state) {
	OptSet("Recent_Sub_State",new_state)
	return new_state
}
;--------- LOG FOLDERS
GetRecentLogFoldersState()	{
	st := OptGet("RC_LogFolders")
	if st not in 0,1
		st := 1
	if A_OSVersion in WIN_XP,WIN_2003,WIN_2000
		if !GetAddressStateXP()
			st := 0
	return st
}

SetRecentLogFoldersState(new_state)	{
	OptSet("RC_LogFolders",new_state)
	return	new_state
}
;--------- LOG PROCESSES
GetRecentLogProcsState()	{
	st := OptGet("RC_LogProcs")
	if st not in 0,1
		st := 0
	return st
}

SetRecentLogProcsState(new_state) {
	OptSet("RC_LogProcs",new_state)
	return	new_state
}
;--------- LOG WIN RECENT
GetRecentWinLog()	{
	st := OptGet("RC_LogWinRecent")
	if st not in 0,1
		st := 1
	if !GetWindowsRecentState()
		st := 0
	return st
}

SetRecentWinLog(new_state)	
{
	if (!GetWindowsRecentState() && new_state = 1)
	{
		MsgBox, 52, Windows Recent Items disabled,It seems you have Recent Items tracking disabled in Windows.`nYou must enable it in order to use this feature in Quick Cliq.`n`nDo you want to do this now?
		IfMsgBox, Yes
			EnableWindowsRecent()
	}
	OptSet("RC_LogWinRecent",new_state)
	return	new_state
}

GetRecentFolder()
{
	RegRead, recent_folder, HKCU, Software\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders, Recent
	return recent_folder
}
;--------- LOG RECENT SHORTCUTS
GetRecentLogShortcuts()
{
	st := OptGet("RC_LogRecentShortcuts")
	if st not in 0,1
		st := 1
	return st
}

SetRecentLogShortcuts(state)
{
	OptSet("RC_LogRecentShortcuts",state)
	return
}
;--------- ITEMS IN MENU
GetRCItemsCount()	{
	global RC_MINITEMS, RC_MAXITEMS
	ct := OptGet("RC_Count")
	if ct not between %RC_MINITEMS% and %RC_MAXITEMS%
		ct := 7
	return ct
}

SetRCItemsCount(new_count)	{
	OptSet("RC_Count",new_count)
	return	new_count
}
;###############################################################
SaveUseTime()
{
	global QC_START_TIME
	Curtime := A_Now
	EnvSub, Curtime, %QC_START_TIME%, Seconds
	usetime := OptGet("Settings_CT")
	if (usetime != "ERROR" && usetime != "")
		if usetime is digit
			Curtime += usetime
	OptSet("Settings_CT",Curtime)
	return
}

GetUseTime()
{
	global QC_START_TIME
	Curtime := A_Now
	EnvSub, Curtime, %QC_START_TIME%, Seconds
	usetime := OptGet("Settings_CT")
	if (usetime != "ERROR" && usetime != "")
		if usetime is digit
			Curtime += usetime
	Curtime := Floor(Curtime/86400) . " Days " . Floor(Mod(Curtime,86400)/3600) . " Hours " . Floor(Mod(Mod(Curtime,86400),3600)/60) . " Minutes "
	Return Curtime
}

GetTGNotifyState()		;getting state of tooltip notfication when gesture temporarily disabled
{
	st := OptGet("TGNotify")
	if st not in 0,1
		st := 1
	return st
}

SetTGNotifyState(state)
{	
	OptSet("TGNotify",state)
	return state
}

GetLightMenuState()	;Light-Style menu state
{
	st := OptGet("LightMenu")
	if st not in 0,1
		st := 0
	return st	
}

SetLightMenu(state)
{
	OptSet("LightMenu",state)
	return state
}
;######### Help Shortcut
GetHelpItemState()
{
	st := OptGet("HideHelpItem")
	if st not in 0,1
		st := 0
	return st
}

SetHelpItemState(state)
{
	OptSet("HideHelpItem",state)
	return state
}
;######### HIDE SUSPEND MENU
GetSuspendItemState()
{
	st := OptGet("HideSuspendItem")
	if st not in 0,1
		st := 0
	return st
}

SetSuspendItemState(state)
{
	OptSet("HideSuspendItem",state)
	return state	
}
;###############################################################
;######### FEATURES STATES
GetMemosState()
{
	global DEFAULT_FEATURES_STATE
	st := OptGet("Memos_On")
	if st not in 0,1
		st := DEFAULT_FEATURES_STATE
	return st	
}

GetWindowsState()
{
	global DEFAULT_FEATURES_STATE
	st := OptGet("Win_Hide_Enabled")
	if st not in 0,1
		st := DEFAULT_FEATURES_STATE
	return st	
}

GetClipsState()
{
	global DEFAULT_FEATURES_STATE
	st := OptGet("ClipXEnabled")
	if st not in 0,1
		st := DEFAULT_FEATURES_STATE
	return st
}

GetClipsSave()
{
	st := OptGet("ClipsSaveOnExit")
	if st not in 0,1
		st := 0
	return st	
}

SetClipsSave(state)
{
	OptSet("ClipsSaveOnExit",state)
	return state
}
;######### FEATURES HOTKEYS
GetMainHotkey()
{
	global MAIN_DEFAULT_HOTKEY
	hk := OptGet("HotKeyString")
	if (hk = "ERROR" || hk = "")
		hk := MAIN_DEFAULT_HOTKEY
	return hk
}

GetClipsHotkey()
{
	global CLIPX_DEFAULT_HOTKEY
	hk := OptGet("ClipXHotkey")
	if (hk = "ERROR" || hk = "")
		hk := CLIPX_DEFAULT_HOTKEY
	return hk
}

GetMemosHotkey()
{
	global MEMOS_DEFAULT_HOTKEY
	hk := OptGet("Memos_Hotkey")
	if (hk = "ERROR" || hk = "")
		hk := MEMOS_DEFAULT_HOTKEY
	return hk
}

GetWindowsHotkey()
{
	global WIN_HIDE_DEFAULT_HOTKEY
	hk := OptGet("Win_Hide_Show_Hotkey")
	if (hk = "ERROR" || hk = "")
		hk := WIN_HIDE_DEFAULT_HOTKEY
	return hk
}

GetHideAWindowHotkey(for_help = 0)		;if for_help = 1 function will return actual hotkey for hiding window (it may be CTRL+Space)
{
	global HIDE_WINDOW_DEFAULT_HOTKEY
	cp := OptGet("WH_UseCSpace")
	if cp not in 0,1
		cp := 1	
	hk := OptGet("Hide_OptionalHotkey")
	if (hk = "ERROR" || hk = "")
		hk := HIDE_WINDOW_DEFAULT_HOTKEY
	if (cp && for_help)
		return "^Space"
	else
		return hk
}

GetRecentHotkey() {
	global DEFAULT_RECENT_HOTKEY
	hk := OptGet("Recent_Hotkey")
	if (hk = "ERROR" || hk = "")
		hk := DEFAULT_RECENT_HOTKEY
	return hk
}

;######### FEATURES GESTURES
GetMainGesture()
{
	global MAIN_DEFAULT_GESTURE
	gs := OptGet("MainGesture")
	if RegExMatch(gs,"[^RLUD]")
		gs := MAIN_DEFAULT_GESTURE
	return gs
}

GetClipsGesture()
{
	global CLIPX_DEFAULT_GESTURE
	gs := OptGet("ClipXGesture")
	if RegExMatch(gs,"[^RLUD]")
		gs := CLIPX_DEFAULT_GESTURE
	return gs
}

GetMemosGesture()
{
	global MEMOS_DEFAULT_GESTURE
	gs := OptGet("Memos_Gesture")
	if RegExMatch(gs,"[^RLUD]")
		gs := MEMOS_DEFAULT_GESTURE
	return gs
}

GetWindowsGesture()
{
	global WIN_HIDE_DEFAULT_GESTURE
	gs := OptGet("Win_Hide_Gesture")
	if RegExMatch(gs,"[^RLUD]")
		gs := WIN_HIDE_DEFAULT_GESTURE
	return gs
}
;######### GESTURES BUTTON
GetGestureButton(AsText=0)
{
	ggb := OptGet("GlobalGestureButton")
	If ggb not in RButton,MButton,XButton1,XButton2
		ggb := "RButton"
	if AsText
	{
		if (ggb = "RButton")
			ggbf = Right Mouse Button
		else if (ggb = "MButton")
			ggbf = Middle Mouse Button
		else if (ggb = "XButton1")
			ggbf = Mouse 3 button
		else if (ggb = "XButton2")
			ggbf = Mouse 4 button
		return ggbf
	}
	else
		return ggb
}
;######### ICONS SIZE
GetIconSize()
{
	size := OptGet("ICONS_SIZE")
	if (size != 16 && size != 24 && size != 32)
		size := 16
	return size
}

SetIconSize(value)
{
	global global_Icons_Size
	OptSet("ICONS_SIZE",value)
	global_Icons_Size := value
	DF_DestroyIcons()
	DF_SetIconsHandle()
	return size
}
;######### TV Default colors
GetTVDefColors()
{
	state := OptGet("TV_DefColors")
	if state not in 0,1
		state := 0
	return state
}

SetTVDefColors(state)
{
	OptSet("TV_DefColors",state)	
	return state
}
;######### Autosave button
GetTargetAutosaveState()
{
	state := OptGet("targetAutosave")
	if state not in 0,1
		state := 0
	return state
}

SetTargetAutosaveState(state)
{
	OptSet("targetAutosave",state)
	return
}
;################ CLIPS HOTKEYS SETTINGS
Clips_GetCopyHK()
{
	hk := OptGet("Clips_CopyHK")
	if (hk = "ERROR")
		hk = ^										;ctrl
	return hk
}

Clips_SetCopyHK(new_hk)
{
	OptSet("Clips_CopyHK",new_hk)
	return new_hk
}

Clips_GetAppendHK()
{
	hk := OptGet("Clips_AppendHK")
	if (hk = "ERROR")
		hk = #^										;win+ctrl
	return hk
}

Clips_SetAppendHK(new_hk)
{
	OptSet("Clips_AppendHK",new_hk)
	return new_hk
}

Clips_GetPasteHK()
{
	hk := OptGet("Clips_PasteHK")
	if (hk = "ERROR")
		hk = !									;Alt
	return hk
}

Clips_SetPasteHK(new_hk)
{
	OptSet("Clips_PasteHK",new_hk)
	return new_hk	
}
;###################### ITEMS HEIGHT ADJUSTMENT
SetItemsHeight(value)
{
	OptSet("Items_Height",value)
	return value
}

GetItemsHeight()
{
	value := OptGet("Items_Height")
	if value is not digit
		value = 0
	return value
}
;###################### ICONS ONLY OPTION
GetOptIconsOnly()
{
	st := OptGet("Menu_IconsOnly")
	if st not in 0,1
		st = 0
	return st
}

SetOptIconsOnly(value)
{
	OptSet("Menu_IconsOnly",value)
	return value
}
;###################### DIVIDE ITEMS BY COLUMNS OPTION
GetOptUseColumns()
{
	st := OptGet("Menu_UseColumns")
	if st not in 0,1
		st = 0
	return st
}

SetOptUseColumns(value)
{
	OptSet("Menu_UseColumns",value)
	return value
}

GetOptMaxPerColumn()
{
	st := OptGet("Menu_MaxPerCol")
	if st is not digit
		st = 10
	return st
}

SetOptMaxPerColumn(value)
{
	OptSet("Menu_MaxPerCol",value)
	return value
}

GetOptBarBreak()
{
	st := OptGet("Menu_BarBreak")
	if st not in 0,1
		st = 0
	return st
}

SetOptBarBreak(value)
{
	OptSet("Menu_BarBreak",value)
	return value
}

GetUserName()
{
	st := OptGet("fb_UserName")
	if (st != "ERROR" && st != "")
		return st
	else
		return ""
}

SaveUsername(value)
{
	OptSet("fb_UserName",value)
	return value	
}

GetUserEmail()
{
	st := OptGet("fb_UserEmail")
	if (st != "ERROR" && st != "")
		return st
	else
		return ""
}

SaveUserEmail(value)
{
	OptSet("fb_UserEmail",value)
	return value
}
;Startup

GetStartup()
{
	st := OptGet("RunOnStartup")
	if st not in 0,1
		st = 0
	return st
}

SetStartup(value)
{
	OptSet("RunOnStartup",value)
	return value
}

;Context Item

GetQCContext()
{
	st := OptGet("ContextOption")
	if st not in 0,1
		st = 0
	return st
}

SetQCContext(value)
{
	OptSet("ContextOption",value)
	return value
}

;-------------------------------Tooltips when icons only shown

GetOptShowTlp()
{
	st := OptGet("NoIconsTooltips")
	if st not in 0,1
		st := 1
	return st
}

SetOptShowTlp(value)
{
	OptSet("NoIconsTooltips",value)
	return value
}

;------------------------------Gui Theme option

GetGuiThemeState()
{
	st := OptGet("RemoveGuiTheme")
	if st not in 0,1
		st := 0
	return st
}

SetGuiThemeState(value)
{
	OptSet("RemoveGuiTheme",value)
	return value
}

;------------------------------Props Gui Visible style option

GetPropsStyle()
{
	st := OptGet("PropsHideWnd")
	if st not in 0,1
		st := 1
	return st
}

SetPropsStyle(value)
{
	OptSet("PropsHideWnd",value)
	return value
}

;------------------------------Main Gui Cmd View mode (line edit/LV)

SetCmdView(value)
{
	OptSet("CmdViewMode",value)
	return value
}

GetCmdView()
{
	st := OptGet("CmdViewMode")
	if st not in 0,1
		st := 1
	return st
}

;------------------------------Main Gui Size Saving

MGSaveSize()
{
	global hMGGui
	OptSet("MG_Pos", WinGetPos( hMGGui ))
	return
}

MGGetSize()
{
	pos := OptGet("MG_Pos")
	if ( pos = "error" )
		return
	return pos
}

;------------------------------Icons/Commands relative paths

class QC_Options
{
	__Get( option )
	{
		nm := "opt_" option
		if ObjHasKey( this, nm )
			return this[ nm ]
		else
		{
			value := OptGet( option )
			if ( value = "ERROR" || value = "" )
				value := this.OptDefault( option )
			this.insert( nm, value )
			return value
		}
	}
	__Set( option, value )
	{
		nm := "opt_" option
		this.insert( nm, value )
		OptSet( option, value )
		return value
	}
	
	OptDefault( option )
	{
		return 0
	}
}

