﻿Program_Update(Gui,isSilent = 0)
{
	global MB_NAME, PROGRAM_VERSION,LAST_VER_URL, UPDATER_PATH, LAST_VER_PATH, UPDATER_URL, A_QCarch

	if Gui is not Integer
		return
	if !isSilent
	{
		Gui, %Gui%:+OwnDialogs
		SplashWait(1,"Please Wait...",Gui,0,3)
	}
	sleep 100
	FileDelete, %UPDATER_PATH%
	FileDelete, %LAST_VER_PATH% 
	URLDownloadToFile, %LAST_VER_URL%, %LAST_VER_PATH% ;downloading file with last version number
	if ErrorLevel
	{
		if !isSilent
			MsgBox,,Error, Error occured.`nMake sure you are connected to the internet and try again.`n`nerror code 0
		SplashWait(0,"",Gui,0,3)
		return
	}
	f := FileOPen(LAST_VER_PATH,"r","CP0")
	last_ver := f.ReadLine()
	if !IsObject(f)
	{
		if !isSilent
			MsgBox,,Error, Error occured.`nPlease try again later.`nerror code 1
		SplashWait(0,"",Gui,0,3)
		return
	}
	f.Close()
	if RegExMatch(last_ver,"404|403|401|400|500|502|503|Bad file request|Connection refused by host|Failed DNS lookup|Host unavailable|Host unknown|Network connection was refused by the server|Permission denied|Too many connections|Too many users",Matchd) ;if file was failed to download
	{
		if !isSilent
			MsgBox,,Error, Error occured.`nCheck your internet connection and try again later.`nerror code 2`n`n%Matchd%
			Matchd =
		SplashWait(0,"",Gui,0,3)
		return
	}
	last_ver := RegExReplace(last_ver,"`a)(\s|`n)")
	if VerCompare(last_ver,PROGRAM_VERSION)
	{
		MsgBox,36,New version found,A new version of "%MB_NAME%" found`. Do you want to update now?
		IfMsgBox, No
		{
			SplashWait(0,"",Gui,0,3)
			return
		}
		SplashWait(1,"Please wait...",Gui,0,3)
		
		URLDownloadToFile, %UPDATER_URL%, %UPDATER_PATH% ;downloading updater
			if ErrorLevel
			{
				MsgBox,,Error, Error occured.`nPlease try again later.`nerror code 3
				SplashWait(0,"",Gui,0,3)
				return
			}
		SplashWait(0,"",Gui,0,3)
		PID := DllCall("GetCurrentProcessId")
		OnMessage(0x7779, "ExitQC")
		Run, %UPDATER_PATH% %PID% "%A_ScriptFullPath%" %PROGRAM_VERSION% %last_ver% %A_QCarch%,,UseErrorLevel
			if (ErrorLevel == "ERROR")
			{
				MsgBox,,Error, Failed to run Updater.`nPlease try again.`nerror code 9
				SplashWait(0,"",Gui,0,3)
				OnMessage(0x7779, "")
				return
			}
		SplashWait(0,"",Gui,0,3)
		return
	}
	else
	{
		if !isSilent
		{
			MsgBox,64,New version wasn't found, You are already running the most recent version of Quick Cliq.
			SplashWait(0,"",Gui,0,3)
		}
		SplashWait(0,"",Gui,0,3)
		OnMessage(0x7779, "")
		return
	}
	return
	

}

VerCompare(num1,num2)
{
	if RegExMatch(num2,".*?(?=b\d+\s*$)", match )
	{
		num1 := RegExReplace(num1,"[^0-9]")
		num2 := RegExReplace(match,"[^0-9]")
		res := num1 >= num2
	}
	else {
		num1 := RegExReplace(num1,"[^0-9]")
		num2 :=	RegExReplace(num2,"[^0-9]")
		res := num1 > num2
	}
	return res
}