﻿QCPathMakeRelative( path )
{
	path := QCRemoveSpecials( path, prefix, postfix )
	args := PathGetArgs( path )
	if args
		PathRemoveArgs( path )
	path := PathRelativeTo( path )
	path := prefix path (args ? " " args : "") postfix
	return path
}

QCPathMakeFull( path )
{
	path := QCRemoveSpecials( path, prefix, postfix )
	args := PathGetArgs( path )
	if args
		PathRemoveArgs( path )
	path := PathResolve( path )
	path := prefix path (args ? " " args : "") postfix
	return path
}

;############################### GET ICON FROM TARGET
GetIconFromTarget( shortcut_Target, shortcut_Name ) {
	global SEPARATOR_STRING
	MenuSection := RegExReplace(shortcut_Target,"#[^#]*$")
	order := 0
	Loop
	{
		name := ItemGet(order,MenuSection)
		if (name == "ERROR")
			return 0
		StringReplace, name, name, #B#
		StringReplace, name, name, #M#
		if (name == shortcut_Name)
		{
			icon := ItemGet(order . "#ICON",MenuSection)
			if (icon != "ERROR")
				Return icon
			else 
				return 0
		}
		order++
	}
}
;############################### GET ICON
GetIcon( ID ) {
	global SEPARATOR_STRING
	MenuSection := GetTarget(TV_GetParent(ID))
	TV_GetText(ItemName,ID)
	order := 0
	Loop
	{
		name := ItemGet(order,MenuSection)
		if (name == "ERROR")
			return
		StringReplace, name, name, #B#
		StringReplace, name, name, #M#
		if (name == ItemName)
		{
			icon := ItemGet( order . "#ICON", MenuSection )
			if ( icon != "ERROR" )
				Return icon
			else 
				return
		}
		order++
	}
}

;#################### GETITEMID #######################################
GetItemId( InputID )	{
	InputID := RegExReplace(InputID, "[ =]","")	;removing spaces, =
	return InputID
}

EditShortcut( M_ID, M_TITLE )
{
	global MB_NAME
	Gui, 1:Default
	AddMenuGui()
	Gui, +OwnDialogs
	SplashWait(1,"","")
	WinWait, %MB_NAME%,, 8
	if errorlevel
		return
	StringReplace,M_ID,M_ID,#M#,,1
	StringReplace,M_TITLE,M_TITLE,#M#,,1
	StringReplace,M_ID,M_ID,#B#,,1
	StringReplace,M_TITLE,M_TITLE,#B#,,1
	ItemID = 0
	Loop
	{
		ItemID := TV_GetNext(ItemID, "Full")
		if not ItemID
			break
		TV_GetText(ItemText, ItemID)
		if (ItemText = M_TITLE)
			if ( GetTarget( ItemID ) = M_ID)
			{
				TV_Modify( ItemID, "Select Vis")
				SplashWait(0,"","")
				return
			}
	}
	SplashWait(0,"","")
	MSgBox,,Shortcut wasn't found, Sorry`, desired shortcut wasn't found.
	return
}

GetTargetsList(tg)
{
	global MULTI_TARGET_DIVIDER
	a := StrSplit(tg,MULTI_TARGET_DIVIDER,A_Tab A_Space)
	for ind,tg in a
	{
		if (strlen(tg)>100)
			str := substr(tg,1,100) . "..."
		else
			str := tg
		targets_list .= (ind=1 ? "" : "`n") . str
	}
	return targets_list
}

CheckIniEncoding()
{
	global SETSNAME, MENUITEMSINI, WINDOWS_INI
	c := Object(), c.SETSNAME := SETSNAME, c.MENUITEMSINI := MENUITEMSINI, c.WINDOWS_INI := WINDOWS_INI
	for ini,path in c
	{
		f := FileOpen(path,"r","CP0")
		if (IsObject(f) && f.Encoding != "UTF-16")
		{
			content := f.read()
			f.close()
			f := FileOpen(path,"w","UTF-16")
			f.Write(content)
		}
		f.close()
	}
	return
}

ExitQC(wParam, lParam, msg, hwnd)
{
	ExitApp
	return
}

GetBrushHandle( clr )	;ex. 0xaabbcc
{
	global brushes_handles
	if !RegExMatch(brushes_handles,"`am)^" . clr . "\|\K[\-0-9]+?$",handle)
	{
		handle := API_CreateSolidBrush( clr )
		brushes_handles .= "`n" . clr . "|" . handle
	}
	return handle
}