﻿RunTarget(target,is_smenu=0,ShortcutName = "",ShortcutID = "",DontLog = 0,DontCTRL = 0)
{
	global ContextMenuOnGoing, DEFAULT_MULTI_TARGET_DELAY, MULTI_TARGET_DIVIDER, IsLogRunningShortcuts, Recent_On, QC_ICO
	global window
	
	if (IsLogRunningShortcuts && Recent_On && !DontLog)
	{
		sh_name := ShortcutName ? ShortcutName : "QC_Shortcut"
		qc_icon := (ShortcutID && ShortcutName) ? GetIconFromTarget(ShortcutID,ShortcutName) : QC_ICO
		AddNewRecentItem(sh_name									;name
						,qc_icon									;icon
						,A_Now . SubStr(GetItemId(ShortcutID),1,40)	;id
						,target)									;cmd
		sh_name =
		qc_icon =
	}
	targetsArray := StrSplit(target,MULTI_TARGET_DIVIDER,A_TAB A_SPACE )
	if (GetKeyState("Ctrl") && !DontCTRL)
	{
		Clipboard =
		for ind,val in targetsArray
			Clipboard .= (ind = 1 ? "" : "`r`n") . val
		DTP("Target(s) copied to clipboard:`n" . Clipboard,2000)
		if is_smenu
			sleep 2000
		return
	}
	mdelay := GetMultiDelay()
	hModule := DllCall("LoadLibraryW", "str", "Shlwapi.dll","UPtr") 
	for tg_index,target in targetsArray
	{
		if (tg_index != 1)
			sleep,% mdelay
		if (target = "")
		{
			ErrorsOccured := 1
			errors_string .= "------------------------`nTarget: " . tg_index . "`n" . target . "`nError:`nTarget is empty`n"
			continue
		}
		if RegExMatch(target,"i)^\s*REP\K[0-9]+(?=\s+.*)",rep_num)			;define number of times to repeat current target
			target := RegExReplace(target,"i)^\s*REP[0-9]+\s+(?=.*)")
		else
			rep_num := 1			
		;Special commands ############
		if RegExMatch(target,"i)^\s*W[0-9\.]+\s*$",time_to_wait)	;if target = time to wait
		{
			StringTrimLeft,time_to_wait,time_to_wait,1
			sleep, % (time_to_wait * 1000)
			continue
		}
		if (RegExMatch(target,"i)^\s*CHK\s*$") && !is_smenu)		;if target = CHK
		{
			CustomHotkeysGui_Show()
			continue
		}
		if RegExMatch(target,"i)^\s*RUNAS\s+.*")		;if target contain word RUNAS_ case-insensitive
		{
			loop, %rep_num%
			{
				if (tg_index != 1)
					sleep,% mdelay
				r_val := RunAsAdmin( target )
				if (r_val < 32)
				{
					errors_string .= "------------------------`nTarget: " . tg_index . "`n" . target . "`nError:`n" . GetShellExecuteError(r_val) . "`n"
					ErrorsOccured := 1
					break
				}
			}
			continue
		}	
		if RegExMatch(target, "i)^\s*(win_casc|win_tasksw|win_tileh|win_min|win_unmin|win_togd|win_tilev)\s*$")
		{
			WinCmd(target)
			continue
		}
		if RegExMatch(target, "i)^\s*copyto\K[*^]*\s*.*$",match_out)
		{
			CopyCmd(match_out,window)
			continue
		}
		if (SubStr(target,0) = "^")
		{
			StringTrimRight, target,target,1
			if ChangeFolderTo(window,"",target,0)
				continue
		}
		;target		;target before modifications to use in errors_string in case failure
		args := workDir := ""
		if isUrl := PathIsURL( target )
			exec_path := target
		else
		{
			exec_path := PathSplit( target, args, workDir )
			exec_path := ParseEnvVars( exec_path )
		}
		
		loop,%rep_num%
		{
			if (tg_index != 1)
				sleep,% mdelay
			retval := API_ShellExecute( exec_path, args, workDir)	
			if (retval < 32)	;trying second chance by enclosing entire target in quotes
			{
				err_msg := "------------------------`nTarget: " . tg_index . "`n" . exec_path . (args ? ("`nArguments:`n" . args) : "") . "`nError:`n" . GetShellExecuteError(retval) . "`n"	;saving original err msg
				if !isUrl
				{
					target = "%target%"
					exec_path := PathSplit( target, args, workDir )
					exec_path := ParseEnvVars( exec_path )
					retval := API_ShellExecute( exec_path, args, workDir )	
				}
				if (retval < 32)
				{			
					errors_string .= err_msg
					ErrorsOccured := 1
					break
				}
			}
		}
	}
	if ErrorsOccured
		MsgBox, 16, Error!, One or more targets for this shortcut is not valid. Details below.`n`n%errors_string%
	DllCall("FreeLibrary", "Ptr", hModule)
	return
}

GetShellExecuteError(err_code)
{
	if (err_code = 0)
		err_descr = The operating system is out of memory or resources.
	else if (err_code = 2)
		err_descr = The specified file was not found.
	else if (err_code = 3)
		err_descr = The specified path was not found.
	else if (err_code = 11)
		err_descr = The .exe file is invalid (non-Win32 .exe or error in .exe image).
	else if (err_code = 5)
		err_descr = The operating system denied access to the specified file.
	else if (err_code = 27)
		err_descr = The file name association is incomplete or invalid.
	else if (err_code = 30)
		err_descr = The DDE transaction could not be completed because other DDE transactions were being processed.
	else if (err_code = 29)
		err_descr = The DDE transaction failed.
	else if (err_code = 28)
		err_descr = The DDE transaction could not be completed because the request timed out.
	else if (err_code = 32)
		err_descr = The specified DLL was not found.
	else if (err_code = 31)
		err_descr = There is no application associated with the given file name extension. This error will also be returned if you attempt to print a file that is not printable.
	else if (err_code = 8)
		err_descr = There was not enough memory to complete the operation.
	else if (err_code = 26)
		err_descr = A sharing violation occurred.
	else
		err_descr = error code %err_code%
	return err_descr
}