﻿/*
Functions for creating S-menus
*/

CopySMenu(menu_ID,dest_file)
{
	global MENUITEMSINI
	ini := MENUITEMSINI
	qcm := dest_file
	FileDelete,% qcm
	Gui, 1:Default
	menu_Target := GetTarget(menu_ID)
	;Copying selected menu section
	IniRead,content,% ini,% menu_Target
	IniWrite,% content,% qcm,% menu_Target
	;-- Geeting Menu Colors
	IniRead,rsl,% qcm,% menu_Target,MenuColor
	if (rsl = "ERROR" || rsl = "")
		IniWrite,% MenuGetColor("bg",menu_ID),% qcm,% menu_Target,MenuColor
	IniRead,rsl,% qcm,% menu_Target,TextColor
	if (rsl = "ERROR" || rsl = "")
		IniWrite,% MenuGetColor("t",menu_ID),% qcm,% menu_Target,TextColor
	;Looping
	next_ID := menu_ID
	pid := menu_ID = 0 ? -1 : TV_GetParent(menu_ID)
	Loop
	{
		next_ID := TV_GetNext(next_ID,"F")
		if (next_ID=0 || TV_GetParent(next_ID) == pid)
			break

		if TV_GetChild(next_ID)
		{
			IniRead,content,% ini,% mtg := GetTarget(next_ID)
			IniWrite,% content,% qcm,% mtg
			continue
		}
		;getting targets for each item
		item_target := GetTarget(next_ID)
		iniRead,item_value,% ini,Targets,% item_target
		if !(item_value = "ERROR" || item_value = "")
		{
			def = ^"\s*(?!").*(?<!")\s*"$
			if RegExMatch(item_value,def)				;if target is enclosed in quotes once from the both sides
				item_value := RegExReplace(item_value,"(^\s*""|""\s*$)","""""")		;then we make em double quotes because one from each side will be removed on ini reading
			IniWrite,% item_value,% qcm,Targets,% item_target
		}
	}
	return
}

RunSMenu(qcm_file)
{
	global smenu_Ini,MM_TRANSPARENCY
	smenu_Ini := qcm_file
	IniRead,sections_list,% smenu_Ini
	StringSplit, section, sections_list,`n,%A_Tab%%A_Space%
	hMenu := CreateSMenu(qcm_file,section1,"","",1)
	MouseGetPos,X,Y
	MMenu_Show(hMenu,X,Y, "RunSMenuTarget","SSM_SelectHandle USM_MenuCloseHandle RSM_RBHandle ISM_MenuOpenHandle MSM_MBHandle",MM_TRANSPARENCY)
	return
}

CreateSMenu(qcm_file,MName,Mcol="",Tcol="",Initial = 0)	
{
	global
	local order, MColor, TColor, IName, Bold, sub, iIcon, ItemDIsabled, icoindex, df_m, next_item_ID
	if Initial
	{
		df_targets := df_built_menus := df_menus := df_targets_count := ""	;Folder Menu related vars
		global_LightMenu := GetLightMenuState()
		ItemsHeight_adj := GetItemsHeight()
		global_Icons_Size := GetIconSize()
		global_IconsOnly := global_LightMenu ? 0 : GetOptIconsOnly()
		global_UseColumns := GetOptUseColumns()
		if global_UseColumns
		{
			global_MaxPerCol := GetOptMaxPerColumn()
			global_ColBarBreak := GetOptBarBreak()
		}
	}

	MColor := GetMenuColor(MName,"MenuColor",Mcol,qcm_file)
	TColor := GetMenuColor(MName,"TextColor",Tcol,qcm_file)
;~ 	##################
	QC_MMenus[MName] := MMenu_Create("S" . global_Icons_Size . " C" . MColor . " O" . ICON_OFFSET . " T" . TColor . " I" . ItemsHeight_adj,global_LightMenu)
	order := 0
	Loop
	{
		IniRead, IName, %qcm_file%, %MName%, %order%
		if (IName == "ERROR")
			break
;~ 	######### ICON
		IniRead, iIcon, %qcm_file%, %MName%, %order%#ICON
		if (iIcon == "ERROR")
			iIcon := ""
;~ 	##################	
		IfInString, IName, #B# ; if bold
		{
			StringReplace, IName, IName, #B# 
			Bold := "d"
		}
		else
			Bold := ""
		IfInString, IName, #M# ;if submenu
		{
			StringReplace, IName, IName, #M#
			sub := " m" . CreateSMenu(qcm_file,MName . "#" . GetItemId(IName),MColor,TColor)
		}
		else
			sub := ""
		
		next_item_ID := GetItemId(MName . "#" . IName)
		if (substr(IName,0) = "*")
		{
			df_m := MMenu_Create("S" . global_Icons_Size)
			df_menus .= "`n" . df_m . "|" . DF_GetTarget(next_item_ID,qcm_file)
			next_item_ID := "DF_" . next_item_ID
			MMenu_Add(df_m, "- :Open Folder: -",DF_OPEN_FOLDER . "_DF","","iDF_DFM_" . df_m)
			sub := " m" . df_m
		}		
		
;~ 	##################	
		icoindex := IconGetIndex(iIcon)
		If RegExMatch(IName,"^#[0-9]*$")
			MMenu_Add(QC_MMenus[MName])
		Else
			MMenu_Add(QC_MMenus[MName], IName, IconGetPath(iIcon) . icodx := (icoindex = "" ? "" : (":" . icoindex)) ,"",Bold . " i" . next_item_ID . sub,global_IconsOnly)
		order++
	}
	return QC_MMenus[MName]
}

; ########################## S-MENU FUNCS
RunSMenuTarget(id,title)
{
	global smenu_Ini,df_menus,df_targets
	if RegExMatch(id,"^DF_\K.*",df_id)
	{
		if RegExMatch(df_id,"^DFM_\K[0-9]+",menu_id)
		{
			if RegExMatch(df_menus,"`am)^" . menu_id . "\|\K.+?$",tg)
				RunTarget(tg,0,"Folder Menu")
		}
		else
			if RegExMatch(df_targets,"`am)^" . df_id . "\|\K.+?$",tg)
				RunTarget(tg,0,"Folder Menu")
	}
	else
	{
		IniRead, target, %smenu_Ini%, Targets, %id%
		if (target != "" && target != "ERROR")
			RunTarget(target,1,title,id)
		else
		{
			DTP("Target empty!",2000)
			sleep 2000
		}
	}
	return
}

SM_SelectHandle(id)
{
	global MAIN_SECTION_NAME, smenu_Ini
	Tooltip
	Made_Selection = 1
	if !GetKeyState("CTRL","P")					;all subsequent command only works if CTRL holded
		return
	if InStr(id,MAIN_SECTION_NAME . "#")		;shows target of focused shortcut
		{
			IniRead, Item_target, %smenu_Ini%, Targets, %id%
			if (Item_target = "ERROR")
			{
				Item_target =
				tooltip
			}
			else
			{
				targets_list := GetTargetsList(Item_target)
				Tooltip Target(s):`n%targets_list%`n`nCTRL+Left Click - copy target to clipboard`nCTRL+Right Click - fast folder change`nMiddle Click - fast folder change
				isExist =
				Item_target =
				targets_list =
			}
			return
		}
	return
}

SM_RBHandle()
{
	if (GetKeyState("CTRL","P") && Made_Selection = 1)
		SetTimer, ChangeFolderTo, -10
	else
		SetTimer, OpenContextMMenu, -50
	return
}

SM_MenuCloseHandle(menu_id)
{
	Tooltip
	Made_Selection = 0
	return	
}

SM_MenuOpenHandle(menu_id)
{
	global df_built_menus
	SetTimer,WatchForMenu,10
	if !instr(df_built_menus,"|" . menu_id . "|")
		DF_BuildDir(menu_id)	
	return
}

SM_MBHandle()
{
	SetTimer, ChangeFolderTo, -1
	return
}