﻿CheckSMenuRegs(set=1)			;checking if reg values for .qcm files are valid, otherwise fixing them
{
	global QC_SMENU_REGNAME, SMenu_msgbox_No
	isvalid = 1
	if (set=0)
	{
		if !A_ISAdmin
		{
			MsgBox,52,Run As Admin?, In order to remove S-Menus settings from the system we will need to make necessary changes to the registry.`n`nWould you like to proceed with running Quick Cliq in an administrative capacity to set this up?
			IfMsgBox, Yes
				API_ShellExecute(A_ScriptFullPath,"-smreg_del", A_ScriptDir,"RUNAS")	
			return
		}	
		RegDelete,HKCR,.qcm
		RegDelete,HKCR,% QC_SMENU_REGNAME
		DllCall("Shell32.dll\SHChangeNotify","Int",0x8000000,"UInt",0)
		return
	}
	RegRead, value, HKCR, .qcm
	if (value != QC_SMENU_REGNAME)
	{
		RegDelete,HKCR, .qcm
		RegWrite,REG_SZ,HKCR, .qcm,,% QC_SMENU_REGNAME
		isvalid = 0
	}
	RegRead, shell_name, HKCR, % QC_SMENU_REGNAME
	if (shell_name != "Quick Cliq Menu")
	{
		RegWrite,REG_SZ,HKCR,% QC_SMENU_REGNAME,,Quick Cliq Menu
		isvalid = 0
	}
	RegRead, is_noext, HKCR, % QC_SMENU_REGNAME,NeverShowExt
	if ErrorLevel
	{
		RegWrite,REG_SZ,HKCR,% QC_SMENU_REGNAME,NeverShowExt
		isvalid = 0
	}
	RegRead, smenu_icon, HKCR,% QC_SMENU_REGNAME . "\DefaultIcon"
	if (smenu_icon != A_ScriptFullPath . ",0")
	{
		RegWrite,REG_SZ,HKCR,% QC_SMENU_REGNAME . "\DefaultIcon",,% A_ScriptFullPath . ",0"
		isvalid = 0
	}
	RegRead, smenu_com, HKCR,% QC_SMENU_REGNAME . "\Shell\Open\Command"
	command = "%A_ScriptFullPath%" -sm "`%1" 
	if (smenu_com != command)
	{
		RegWrite,REG_SZ,HKCR,% QC_SMENU_REGNAME . "\Shell\Open\Command",,% command
		isvalid = 0
	}
	if (!A_ISAdmin && !isvalid)
	{
		MsgBox,52,Run As Admin?, In order to use S-Menus we will need to associate a file type with Quick Cliq. This will involve writing to the registry. If you have already set up S-Menus but are seeing this message then it means that either the command has become corrupt or you have moved Quick Cliq.`n`nWould you like to proceed with running Quick Cliq in an administrative capacity to set this up?
		IfMsgBox, Yes
			API_ShellExecute(A_ScriptFullPath,"-smreg", A_ScriptDir,"RUNAS")
		IfMsgBox, No
			Return "Nope"
	}
	if !isvalid
		DllCall("Shell32.dll\SHChangeNotify","Int",0x8000000,"UInt",0)							;refreshing to make icons appears properly on .qcm files
	return
}