﻿ChangeFolderTo(hWin,iID="",FolderPath="",Tooltips = 1)	;window handle and item ID or path
{
	global MULTI_TARGET_DIVIDER,PMMenu_ID
	WinGetClass, WinClass, ahk_id %hWin%
	if WinClass in #32770,CabinetWClass
	{
		if (iID != "")
			tg := ItemGet(iID,"Targets")
		else
			tg := FolderPath
		if (tg = "" || tg = "ERROR" || InStr(tg,MULTI_TARGET_DIVIDER))
		{
			if Tooltips
				DTP("Wrong target!",1000)
			return 0
		}
		tg := QCRemoveSpecials( tg, pr, ps )
		if RegExMatch( tg, "i)shell:.*", Dir ) 	; check for Shell:* like folders
			isShellDir := 1
		else {
			tg := PathGetDir( tg )
			Dir := PathResolve( tg )
		}
		Dir := PathUnquoteSpaces( Dir )
		if ( PathIsDir( Dir ) || isShellDir )
		{
			;~ MMenu_Hide()
			if (WinClass = "#32770")
				OpenSaveFF(hWin,Dir)
			else if (WinClass = "CabinetWClass")
				ExplorerFF(hWin,Dir)			
		}
		else
		{
			if Tooltips
				DTP("Invalid dir!",1000)
			return 0
		}
	}
	else
	{
		if Tooltips
			DTP("Unsupported window!",1000)
		return 0
	}
	return 1
}

OpenSaveFF(hWin,Dir)
{
	global PMMenu_ID
	if !WaitMODKeysRelease()
		return
	ControlSetText,Edit1,%Dir%,ahk_id %hWin%
	ControlFocus,Edit1,ahk_id %hWin%
	ControlSend,Edit1,{Enter},ahk_id %hWin%
	ControlGetText,control_text,Edit1,ahk_id %hWin%
	if (control_text = Dir)
		ControlSetText,Edit1,,ahk_id %hWin%
	WinActivate, AHK_ID %PMMenu_ID%	
	return
}

ExplorerFF(hWin,Dir) {
	
	global PMMenu_ID
	if A_IsCompiled
		curState := ComObjError( 0 )
	win := GetExplorerItem(hWin)
	if win
		win.Navigate(Dir)
	WinActivate, AHK_ID %PMMenu_ID%	
	if A_IsCompiled
		ComObjError( curState )
	return
}

GetExplorerItem(hwnd)
{
	;http://msdn.microsoft.com/en-us/library/aa752084%28v=VS.85%29.aspx
	wins := ComObjCreate("Shell.Application").Windows
	for item in wins
		if (item.HWND = hwnd)
			return item
	return 0
}

WaitMODKeysRelease()
{
	KeyWait,Alt,T1
		if ErrorLevel 
			Goto,Just_A_Fail
	KeyWait,Ctrl,T1
		if ErrorLevel 
			Goto,Just_A_Fail
	KeyWait,Shift,T1
		if ErrorLevel 
			Goto,Just_A_Fail
	KeyWait,RWin,T1
		if ErrorLevel 
			Goto,Just_A_Fail
	KeyWait,LWin,T1
		if ErrorLevel 
			Goto,Just_A_Fail
	return 1
	
Just_A_Fail:
	DTP("Couldn`'t switch folder`nMake sure your modifier keys (ctrl`,alt`,shift`,win)`nare released",6000)
	return 0
}


OpenContextMMenu(iId,iName,iMenu) {
	global PMMenu_ID
	if (iName = "")
		return
	CMHandle := MMenu_Create("S16")
	MMenu_Add(CMHandle, iName, "",""," iID")
	MouseGetPos, X,Y
	real_handle := MMenu_GetRealHandle(CMHandle)
	Gui 99:+LastFound +HWNDWinHandle
	idn := API_TrackPopupMenu( real_handle, 0x0100|0x0001, X, Y, WinHandle )
	MMenu_Destroy(CMHandle)
	WinActivate, AHK_ID %PMMenu_ID%
	return
}