﻿AddIconsToMenu(hMenu,ico_fol,ico_num=0,num_per_col = 7.5,icons_size = 32,ByRef iCount="",ByRef iList="")
{
	global ICON_OFFSET
	Loop,%ico_fol%\*,2,0	;getting folders only
	{
		subMenu := MMenu_Create("S" . icons_size . " CFFFFFF O" . ICON_OFFSET . " T000000")
		AddIconsToMenu(subMenu,A_LoopFileFullPath,0,num_per_col,icons_size, iCount, iList)
		if (ico_num>=num_per_col)
		{
			div := " b"
			ico_num := 0
		}
		else
			div := ""
		MMenu_Add(hMenu,A_LoopFileName, "","",div . " m" . subMenu,0,1)
		ico_num += 0.5	
	}
	
	Loop,%ico_fol%\*.ico,0,0	;getting files only
	{
		if (ico_num>=num_per_col)
		{
			div := " b"
			ico_num := 0
		}
		else
			div := ""
		MMenu_Add(hMenu,"", A_LoopFileFullPath,"","iIco_" . iCount . div,1)
		iList .= "`n" . iCount . "|" . A_LoopFileFullPath
		ico_num++
		iCount++
	}
	return
}

;######## IconsMenu
; Function Creates menu with icons to choose in main gui
ShowIconsMenu( hWin, oldIco, x="", y="" )
{
	global ICON_OFFSET, USER_ICONS
	icons_size = 32
	num_per_col = 5.5
	icons_list =
	icons_count = 0
	
	hMenu := MMenu_Create("S" . icons_size . " CFFFFFF O" . ICON_OFFSET . " T000000")
	AddStandardIcons( hMenu, num_per_col, icons_size, icons_count, icons_list )
	
	Loop,%USER_ICONS%\*.ico,1,1	;checking if folder have at least one ico
	{
		have_icons = 1
		break
	}
	
	if have_icons
		AddIconsToMenu(hMenu,USER_ICONS, 0.5, num_per_col, icons_size, icons_count, icons_list)
	else
		MMenu_Add(hMenu,"Click here for more info...", "","","iinfo",0,1)
	if (x="" || y="")
		MouseGetPos, X,Y
	id := MMenu_Show(hMenu,X,Y, "","")
	MMenu_Destroy( hMenu )
	newIco := ParseIconId( id, hWin, oldIco, icons_list )
	icons_list =
	Return newIco
}

AddStandardIcons(hMenu,iNum,iSize,ByRef iCount,ByRef iList)
{
	local subMenu, ico_num, div, iEnum
	MMenu_Add(hMenu,"Browse...", "","","ibrowse",0,1)
	MMenu_Add(hMenu)
	MMenu_Add(hMenu,"shell32...", "","","ishell32",0,1)
	MMenu_Add(hMenu,"moricons...", "","","imoricons",0,1)
	MMenu_Add(hMenu,"pifmgr...", "","","ipifmgr",0,1)
	MMenu_Add(hMenu,"compstui...", "","","icompstui",0,1)
	MMenu_Add(hMenu,"DDORes...", "","","iDDORes",0,1)
	MMenu_Add(hMenu,"imageres...", "","","iimageres",0,1)
	MMenu_Add(hMenu,"mmcndmgr...", "","","immcndmgr",0,1)
	MMenu_Add(hMenu,"netshell...", "","","inetshell",0,1)
	MMenu_Add(hMenu,"pnidui...", "","","ipnidui",0,1)
	MMenu_Add(hMenu,"wmploc...", "","","iwmploc",0,1)
	MMenu_Add(hMenu,"wpdshext...", "","","iwpdshext",0,1)
	MMenu_Add(hMenu)
	MMenu_Add(hMenu,"Remove", "","","iremove",0,1)

	subMenu := MMenu_Create("S" . iSize . " CFFFFFF O" . ICON_OFFSET . " T000000")
	MMenu_Add(hMenu,"Quick Cliq", "","","b| m" . subMenu,0,1)
	
	iEnum := SUSPEND_ON_ICO "|" SUSPEND_OFF_ICO "|" ADD_CHANGE_ICO "|" CLIPX_ICO "|" WINHIDE_ICO "|" MEMOS_ICO "|" DF_ICO "|"
	. RECENT_ICO "|" HELP_ICO "|" SUSPEND_ICO "|" REMOTE_ICO "|" SYSTEM_FOLDER "|" FOLDER_ICO "|" EMAIL_ICO "|" URL_ICO
	
	loop,Parse,iEnum,|,%A_Space%%A_Tab%
	{
		if (A_LoopField = "")
			continue
		if (ico_num>=iNum)
		{
			div := " b"
			ico_num := 0
		}
		else
			div := ""
		MMenu_Add(subMenu,"", A_LoopField,"","iIco_" . iCount . div,1)
		iList .= "`n" . iCount . "|" . A_LoopField
		ico_num++
		iCount++
	}
	return
}

ParseIconId( id, hWin, oldIco, iList )
{
	if !id
		return 0
	if RegExMatch(id,"^Ico_\K[0-9]+$",ico_id)
	{
		if RegExMatch(iList,"`am)^" . ico_id . "\|\K.+?$",newIco)
			return newIco
		return 0
	}
	if (id = "browse")
	{
		sIconPath := IconGetPath(oldIco)
		nIndex := IconGetIndex(oldIco)
		if IconPickDlg( hWin, sIconPath, nIndex )
			return sIconPath ":" nIndex
		return 0
	}
	if (id = "remove")
		return -1
	if (id = "info")
	{
		msgbox,64,How to add your own icons,You can choose your favorite icons from this menu.`nJust add them into the folder:`n"%A_WorkingDir%\Data\User_Icons"`nAny subfolders will be recursed.`nOnly .ico files supported.`n`nGood Luck!
		return 0
	}
	if IconPickDlg( hWin, sIconPath := id . ".dll", nIndex := 0 )
		return (sIconPath . ":" .  nIndex)
	return 0
}