﻿/*
Actions are called in QC.ahk, RunTarget, and SystemShortcutsGUI(label = TestSHcuts [create new regex for new command sets])
For each command set there will be one function. Each function will contain sub labels for each command.
"$" will denote a QC command followed directly by the command itself.
If the command does not exist return "No Action Defined" and Run_Target() will continue to try and process the target. This is in case a file name starts with "$"
Each command set will get a new RegEx conditional statement inside RunTarget()
*/

QCRemoveSpecials( cmd, ByRef prefix, ByRef postfix )
{
	prefix := postfix := ""
	if RegExMatch( cmd, "\^$", match )
		postfix .= match, cmd := RegExReplace( cmd, "\^$" )
	if RegExMatch( cmd, "i)^\s*REP[0-9]+\s+", match )
		prefix .= match, cmd := RegExReplace( cmd, "i)^\s*REP[0-9]+\s+" )
	if RegExMatch( cmd, "i)^\s*RUNAS\s+", match )
		prefix .= match, cmd := RegExReplace( cmd, "i)^\s*RUNAS\s+" )
	if RegExMatch( cmd, "i)^\s*copyto[*^]*\s*", match )
		prefix .= match, cmd := RegExReplace( cmd, "i)^\s*copyto[*^]*\s*" )
	return cmd
}

RunAsAdmin( target )
{
	target := RegExReplace(target, "i)^\s*RUNAS\s*")		;removing away RUNAS word from target
	exec_path := PathSplit( target, args, workDir )
	exec_path := ParseEnvVars( exec_path )
	retval := API_ShellExecute( exec_path, args, workDir, "RUNAS" )
	return retval
}

WinCmd(cmd) {
	oShell := ComObjCreate("Shell.Application")
	ret := cmd == "win_casc" ? oShell.CascadeWindows()
			: cmd == "win_tasksw" ? oShell.WindowSwitcher()
			: cmd == "win_tileh" ? oShell.TileHorizontally()
			: cmd == "win_min" ? oShell.MinimizeAll()
			: cmd == "win_unmin" ? oShell.UndoMinimizeALL()
			: cmd == "win_togd" ? oShell.ToggleDesktop()
			: cmd == "win_tilev" ? oShell.TileVertically()
	return
}