﻿class GuiTooltip
{
	lastHWND := ""
	lastGuiCtrl := ""
	tooltipDelay := 600
	
	sizeddl_TT := "Icons size in menu"
	RunOnStartup_TT := "Start " MB_NAME " when Windows starts up"
	addcontx_TT := "Add an option to the Windows Explorer context menu for each file/folder`nallowing you to quickly add a shortcut to the selected file/folder"
	addMemo_TT := "Add new Memo"
	UpperCase_TT := "Upper Case"
	LowerCase_TT := "Lower Case"
	SentenceCase_TT := "Sentence Case"
	TitleCase_TT := "Title Case"
	gesturesOFFnotify_TT := hotkeysOFFnotify_TT := "Currently suspended.`nYou can reenable them through 'Suspend' menu or " MB_NAME " tray menu"
	ToFileButtonClipX_TT := "Save current clip to file as plain text`nCTRL + Click - to save in original format"
	ClearButtonClipX_TT := "Clear current Clip"
	NotepadOpen_TT := "View clip in notepad"
	AutoUpdates_TT := "Will check for updates automatically on each " MB_NAME " start after 2 minutes of run time"
	Plain_TT := "Show selected clipboard as plain text"
	Orig_TT := "Show selected clipboard in original format"
	woNulls_TT := "Show selected clipboard without nulls`nUseful if you can't see whole or a part of the clipboard in original format"
	SortTypeChoice_TT := "Sort items inside selected menu"
	SMenus_TT := "The S-Menu feature allows you to save a submenu you have created as a separate menu`nthat can run outside of " MB_NAME ". The Submenu is saved as a file that is associated with " MB_NAME "."
	IsShowAdd_TT := "Do not show 'Add/Change' item in the menu.`nIf this option enabled`, you can open main window from tray menu or by clicking on any item while holding SHIFT"
	IsTrayHidden_TT := "Do not show " MB_NAME " icon in system tray"
	menus_trans_TT := "Transparency level of menu`n0 - fully transparent`n255 - opaque"
	MiltiDelayEd_TT := "Delay between running commands for a Multi-Command shortcut`nRange 0-10000 milliseconds"
	Gesture_Disable_Time_TT := "Sets the number of seconds Mouse Gestures will be Suspended`nHold Control and click the Suspend Gestures menu item to suspend mouse gestures for this amount of time`n`nMin 5 sec"
	GlobalGestureButton_TT := "Select which mouse button you wish to use with mouse gestures"
	Memo_Encrypt_TT := "Keep current memo encrypted on the disk"
	TempGestDis_TT := "Notify when gestures are temporarily disabled/restored"
	SaveMemosButton_TT := "Save changes you made to memo`nCTRL+S"
	SendMemoE_TT := "E-Mail this memo"
	ontopControl_TT := "Make this window Always-On-Top"
	SuspendItem_TT := "Hide a ""Suspend"" menu which allow temporary disabling of hotkeys/gestures"
	QuickHelpItem_TT := "Hide a ""Help"" item in menu which contains short information about enabled features/hotkeys/gestures"
	ClipsSaveOnExit_TT := "Save clips to files on " MB_NAME " exit and restore on startup"
	LightMenu_TT := "Removes all icons/colors from menu"
	MenuOptIconsOnly_TT := "Show icons only in menu"
	MenuOptColBreak_TT := "Add vertical line between columns"
	ThemeState_TT := "Make windows looking in classic style`nMay solve problems with fonts/colors"
	PwdSessSave_TT := MB_NAME " will keep your password until exit"
	SwitchCmdViewVar_TT := "Switch between single/multi-line view of shortcut commands"
	mgIconRelative_TT := "If enabled, Quick Cliq will always try to save relative path to icons`nUseful for portable use"
	mgCmdRelative_TT := "If enabled, Quick Cliq will always try to save relative path of shortcut's commands`nUseful for portable use"
	
	
	__Get( aName )
	{
		global afo_english
		if ( aName = "AfoSB_TT" )
			return afo_english
		return ""
	}
	
	Show( hwnd, controlName )
	{
		static obj
		this.lastHWND := hwnd
		this.lastGuiCtrl := controlName
		obj := this
		SetTimer, ShowTooltip, -1
		return
		
		ShowTooltip:
			obj._ShowTlp()
			return
	}
	
	_ShowTlp()
	{
		localHWND := this.lastHWND
		tlp_text := this[ this.lastGuiCtrl "_TT" ]
		if (tlp_text = "")
			return
		Loop
		{
			MouseGetPos,Xcur,Ycur,,hwndname,2
			if ( hwndname != localHWND )
				break
			curtime = %A_Sec%%A_MSec%
			tooltip_shown := 0
			Loop
			{
				MouseGetPos,X,Y
				sleep 50
				if (Xcur != X || Ycur != Y)
				{
					tooltip,,,, 9
					break
				}
				if (((A_Sec . A_MSec) - curtime)> this.tooltipDelay && !tooltip_shown) ;tooltip_delay is a delay before showing tooltip
				{
					curtime = %A_Sec%%A_MSec%
					Tooltip,% tlp_text,,,9
					tooltip_shown := 1
				}
			}
		}
		return
	}
}



ShowHyperlink(p_w, p_l, p_m, p_hw)
{
	global oGuiTooltip
	static URL_hover, h_cursor_hand, h_old_cursor, CtrlIsURL, LastCtrl
	WM_SETCURSOR = 0x20
	WM_MOUSEMOVE = 0x200

	If (p_m = WM_SETCURSOR)
	{
		If URL_hover
		  Return, true
	}
	Else If (p_m = WM_MOUSEMOVE)
	{
		; Mouse cursor hovers URL text control
		StringLeft, CtrlIsURL, A_GuiControl, 3
		If CtrlIsURL in URL,URB
		{
			If URL_hover=
			{
				If (CtrlIsURL = "URL")
					Gui, Font,norm cBlue underline
				else									;if URB
					Gui, Font,norm cBlue w700 underline
				GuiControl, Font, %A_GuiControl%
				LastCtrl = %A_GuiControl%
			   
				h_cursor_hand := DllCall("LoadCursorW", "Ptr", 0, "uint", 32649)
			   
				URL_hover := true
			}                 
			  h_old_cursor := DllCall("SetCursor", "Ptr", h_cursor_hand)
		}
		; Mouse cursor doesn't hover URL text control
		Else
		{
			If URL_hover
			{
				StringLeft, CtrlIsURL2, LastCtrl, 3
				If (CtrlIsURL2 = "URL")
					Gui, Font,norm cBlue
				else
					Gui, Font,norm cBlue w700
				GuiControl, Font, %LastCtrl%
				DllCall("SetCursor", "Ptr", h_old_cursor)
			   
				URL_hover=
			}
		}
		oGuiTooltip.Show( p_hw, A_GuiControl )
	}
	return
}

