﻿DisableClipXHotkeys()
{
	global cur_clips_copy_hk, cur_clips_append_hk, cur_clips_paste_hk
	Loop, 9
		{
			if (cur_clips_copy_hk != "")	{
				Hotkey, %cur_clips_copy_hk%%A_Index%, ChangeClips, Off UseErrorLevel
				if ErrorLevel
					MsgBox An Error occured when disabling clips copy hotkey!`n%ErrorLevel%
			}
			if (cur_clips_append_hk != "")	{
				Hotkey,%cur_clips_append_hk%%A_Index%, ChangeClips, Off UseErrorLevel
				if ErrorLevel
					MsgBox An Error occured when disabling clips append hotkey!`n%ErrorLevel%
			}
			if (cur_clips_paste_hk != "")	{
				Hotkey,%cur_clips_paste_hk%%A_Index%, ChangeClips, Off UseErrorLevel
				if ErrorLevel
					MsgBox An Error occured when disabling clips paste hotkey!`n%ErrorLevel%
			}
		}
	ClipXHotkey := OptGet("ClipXHotkey")
	if (ClipXHotkey != "ERROR" && ClipXHotkey != "")
		Hotkey(ClipXHotkey,0,"ShowClipsMenu")
	Else
		Hotkey(CLIPX_DEFAULT_HOTKEY,0,"ShowClipsMenu")
	return
}

ShowClipPreview(clip_id)
{
	global clip_preview=,clip_0
	clip_num := SubStr(clip_id,0)
	clip_%clip_num% := GetPlainText(clip_%clip_num%)
	if (clip_%clip_num% = "")
		clip_preview := "Empty!"
	else if (StrLen(clip_%clip_num%) > 300)
		clip_preview := SubStr(clip_%clip_num%,1,300) . "`n..."
	Else
		clip_preview := clip_%clip_num%
	SetTimer, ShoClipTLP, -500
	return
	
	ShoClipTLP:
		tooltip % clip_preview
		return	
}

Run_Links(das_string,RunOnly = 1)
{
	global MULTI_TARGET_DIVIDER
	if (das_string = "")
		return
	das_string := RemoveNulls(das_string)
	
	Loop
	{
		if !RegExMatch(das_string,"`ai)((http|https|ftp)://|www\.).+?(?=($|[\s<>""``,]))",link)
			break
		StringReplace,das_string,das_string,%link%,,1
		link := URLEscape(link)
		list .= (list ? (RunOnly ? MULTI_TARGET_DIVIDER : "`n") : "") . link
	}
	if (list = "")
	{
		DTP("No links found!")
		return
	}
	if RunOnly
		RunTarget(list,0,"Clips Links")		;is_smenu=0,ShortcutName = "",ShortcutID = "",DontLog = 0,DontCTRL = 0)
	return list
}

SaveClips()
{
	global
	local clip_path, cliphold
	IfNotExist, %CLIPS_SAVEDIR%
		FileCreateDir, %CLIPS_SAVEDIR%
	cliphold := ClipboardAll
	Loop,9
	{
		clip_path = %CLIPS_SAVEDIR%\clip_%A_Index%.txt
		FileDelete,% clip_path
		if (clip_%A_Index% != "")
		{
			Clipboard := clip_%A_Index%
			clip_%A_Index% := ClipboardAll
			f := FileOpen(clip_path,"w","CP0")
			if IsObject(f)
				f.RawWrite(clip_%A_Index%, VarSetCapacity(clip_%A_Index%))
			f.Close()
		}
	}
	Clipboard := cliphold
	free(cliphold)
	return
}

RestoreClips()
{
	global
	local clip_path
	Loop,9
	{
		clip_path = %CLIPS_SAVEDIR%\clip_%A_Index%.txt
		FileRead, clip_%A_Index%, *c %clip_path%
	}
	return
}