﻿MemosMenuRebuild(MenuHandl,MColor="",TColor="",IconsSize=16,justUpdate = 0)
{
	global
	local div
	MMenu_Destroy(MemosHandl)
	MemosHandl := MMenu_Create("S" . IconsSize . " O" . ICON_OFFSET . " c" . MColor . " t" . TColor,global_LightMenu)
	CreateMemosMenu(MemosHandl,MColor,TColor,IconsSize)
	
	if (MemosShowInMain && !justUpdate)
	{
		div := ColDiv(global_itemNum)
		MMenu_Add(MenuHandl, MEMOS_TITLE,MEMOS_ICO,"","i" . MEMOS_TITLE . " m" . MemosHandl . div,global_IconsOnly)
		global_itemNum++
	}
	else
		MMenu_Set(MenuHandl, MEMOS_TITLE, "", "", "m" . MemosHandl)								;used after memos gui closing with justUpdate =1 
	return
}

CreateMemosMenu(m_handl,MColor="",TColor="",IconsSize=16)
{
	global 
	local TO_CLIPBOARD, ON_TOP, EDIT_M, TO_WINDOW, MemosCount
	
	MemosCount := 0
	
	TO_CLIPBOARD := "shell32.dll:146"
	ON_TOP := "shell32.dll:140"
	if A_OSVersion in WIN_XP,WIN_2003,WIN_2000
	{
		EDIT_M := "shell32.dll:55"
		TO_WINDOW := "shell32.dll:97"
	}
	else
	{
		EDIT_M := "shell32.dll:238"
		TO_WINDOW := "shell32.dll:263"
	}
	if A_OSVersion in WIN_XP,WIN_2003,WIN_2000
		MEMO_TO_FILE := "SHELL32.dll:66"
	else
		MEMO_TO_FILE := "SHELL32.dll:68"
	loop								; Free global vars
	{
		if (MemoName%A_Index% == "")
			break
		else
			MemoName%A_Index% =
	}
	
	Loop, %MEMOS_PATH%\*.mmo
	{
		SplitPath, A_LoopFileName,,,,MemoName%A_Index% 					;saving each memo name to the global var for future use
		memo_%A_Index%_handl := MMenu_Create("S" . IconsSize . " O" . ICON_OFFSET . " c" . MColor . " t" . TColor,global_LightMenu)
		MMenu_Add(memo_%A_Index%_handl, "Show On Top", ON_TOP, "", "iMemos_showontop" . A_Index)
		MMenu_Add(memo_%A_Index%_handl, "Edit", EDIT_M, "", "iMemos_edit" . A_Index)
		MMenu_Add(memo_%A_Index%_handl, "E-mail", EMAIL_ICO, "", "iMemos_email" . A_Index)
		MMenu_Add(memo_%A_Index%_handl, "To Current Window", TO_WINDOW, "", "iMemos_window" . A_Index . " b|")
		MMenu_Add(memo_%A_Index%_handl, "To Clipboard", TO_CLIPBOARD, "", "iMemos_clip" . A_Index)
		MMenu_Add(memo_%A_Index%_handl, "To File", MEMO_TO_FILE, "", "iMemos_tofile" . A_Index)
		
		MMenu_Add(m_handl, MemoName%A_Index%,"","","iMemos_" . A_Index . " m" . memo_%A_Index%_handl)
		MemosCount++
	}
	if !MemosCount
		MMenu_Add(m_handl, "No Memos", "", "","iMemos_empty")
	MMenu_Add(m_handl)
	MMenu_Add(m_handl, "Add/Delete", "", "","iMemos_Change")
	
	loop							; Free global vars
	{
		if (memo_%A_Index%_handl == "")
			break
		else
			memo_%A_Index%_handl =
	}
	return
}

MemosActions(M_ID)
{
	global
	if InStr(M_ID,"Memos_Change")
	{
		Memos_Change_GUI()
		return
	}
	loop,3 															;getting proper memo number (starting from 3-digit number) and trimming M_ID
	{
		MemoNum := SubStr(M_ID,-3+A_Index)
		if MemoNum is Digit
		{
			StringTrimRight,M_ID,M_ID,4-A_Index
			break
		}
	}
	ChoosedMemo_name := MemoName%MemoNum% ;getting memo name from array

	if InStr(M_ID,"clip")												;sending memo to clipboard
	{
		MemoToClip(ChoosedMemo_name)
		TrayF := OptGet("HideTrayIcon")
		if (TrayF = 1)
			DTP("Memo copied to clipboard:`n" . ChoosedMemo_name,3000)
		else
			TrayTip, Memo copied to clipboard:,%ChoosedMemo_name%,3, 1
		return
	}
	else if InStr(M_ID,"window")											;sending memo to active window
	{	
		MemoToWindow(ChoosedMemo_name,window)
		return
	}
	else if InStr(M_ID,"showontop")											;sending memo to always-on-top gui window
	{
		ShowMemoOnTop(ChoosedMemo_name)
		return
	}
	else if InStr(M_ID,"edit")
	{
		Memos_Change_GUI()			;opening memos gui
		WinWait, %MEMOS_TITLE%,,3		;waiting till gui appear
		gui, 8:default
		LV_Modify(MemoNum,"Select Vis")		;selecting memo choosed from popup menu
		return
	}
	else if InStr(M_ID,"email")
	{
		if !GetMemoText(memoText, ChoosedMemo_name)
			return
		if (memoText = "")
		{
			DTP("Memo empty!",1000)
			return
		}
		else
		{
			MailEscape(memoText)
			mail_string := "mailto:?subject=" . ChoosedMemo_name . "&body=" . memoText
			Run,% mail_string,,UseErrorLevel
			if errorlevel
				MsgBox,16,Cannot open e-mail client,You probably have no default e-mail client installed
			mail_string =
		}		
	}
	else if InStr(M_ID,"tofile")
		CopyMemoToFile(ChoosedMemo_name)
	return	
}

Memos_Change_GUI()
{
	global
	gui, 8:default
	If IsWindow(hMemosGUI)
	{
		WinActivate, ahk_id %hMemosGUI%
		Return
	}
	MemosGuiRunning := 1
	if global_NoGuiTheme
		Gui,-Theme
	Gui 8:+LastFound
	hMemosGUI := WinExist() + 0
	Menu, MemosActions, Delete

	OnMessage(0x200,"ShowHyperlink")

	gui, add, text, , Memos:
	gui, add, text,xm+160 yp vmemoname_gui w400 R1
	;**------------
	gui, Add, ListView,xm h250 w150 AltSubmit vMemosList hwndmemoHwnd gOnMemoSelect -ReadOnly Count%MemosCount% -Multi -hdr +BackGroundTeal +cWhite, Memos
	Loop, %MEMOS_PATH%\*.mmo
	{
		SplitPath, A_LoopFileName,,,,MemoToAdd
		LV_Add("", MemoToAdd)
	}
	GuiControl, MoveDraw, MemosList
	;**------------
	Gui, Add, Edit, yp xp+160 w400 hp vMemoPreview +Multi +Wrap gMemoPreviewChanged
	LV_Modify(1,"Select")
	GuiControlGet,memo_edit_hwnd,Hwnd,MemoPreview												;saving edit field hwnd
	
	;**------------
	Gui, Add, Button, xm h30 w100 vSaveMemosButton gApplyMemosChanges +Disabled, Save Changes
	Gui, font, s14
	Gui, Add, Button, x+10 h30 W30 vaddMemo gaddMemo, +
	Gui, font, s8
	
	Gui, Add, Button, x+20 h20 W50 vSendMemoE gSendMemoEmail, E-Mail
	gui, add, text, x+10, Case:
	Gui, Add, DropDownList, x+10 vCaseDDL gMemoCaseChange, Upper|Lower|Sentence|Title
	Gui,Add,Button,x+10 vMemoEncrypt Disabled gCryptThatShit,Encrypt
	Gui,Add,Button,x+1 vMemoDecrypt Disabled gCryptThatShit,Decrypt
	Gui, Add, Text, x+10 W70 cBlue vURL_MemoSyntaxHelp gOpen_MemoSyntaxHelp, Syntax Help
	
	If !LV_GetNext()																			;if no memos in list
		GuiControlSet("MemoPreview|CaseDDL|SendMemoE","","Disable",8,0)

	Menu, MemosActions, Add, Show on Top, ShowMemoOnTop_contx
	Menu, MemosActions, Add, Rename, RenameMemo_contx
	Menu, MemosActions, Add, Delete, DeleteMemo_contx
	Menu, MemosActions, Add
	Menu, MemosActions, Add,To File, Save_Memo_To_File
	
	MemosDelConfirm := OptGet("MemosDelConfirm")
	if MemosDelConfirm not in 0,1
		MemosDelConfirm := 1
	Hotkey("^s",1,"ApplyMemosChangesHK",1,"i)^\s*\Q" MEMOS_TITLE "\E\s*$")
	SetCryptControls()
	Gui, Show,, %MEMOS_TITLE%
	MemoToAdd =	
	return

	Open_MemoSyntaxHelp:
		SyntaxHelp()
		return

	SendMemoEmail:
		Gui, 8:Default
		Gui +OwnDialogs
		LV_GetText(MemoName, SelectedRowNumber)
		if !GetMemoText(memoText, MemoName)
			return
		if (memoText = "")
		{
			DTP("Memo empty!",1000)
			return
		}
		else
		{
			MailEscape(memoText)
			mail_string := "mailto:?subject=" . MemoName "&body=" . memoText
			Run,% mail_string,,UseErrorLevel
			if errorlevel
				MsgBox,16,Cannot open e-mail client,You probably have no default e-mail client installed
			mail_string =
		}
		return

	ShowMemoOnTop_contx:
		Gui, 8:Default
		LV_GetText(MemoName, SelectedRowNumber)
		ShowMemoOnTop(MemoName)
		return

	8GuiContextMenu:
		Gui, 8:Default
		if (A_GuiControl = "MemosList" && LV_GetCount() && LV_GetNext() && AllowContx)
		{
			LV_Modify(A_EventInfo,"Focus Select Vis")
			AllowContx := 0
			Menu, MemosActions, Show
		}
		return

	ApplyMemosChanges:
		MemosSaveChanges()
		return


	Save_Memo_To_File:
		Gui, 8:Default
		Gui, +OwnDialogs
		if !LV_GetNext()
		{
			DTP("Choose a memo!")
			return
		}
		LV_GetText(MemoName,LV_GetNext())
		CopyMemoToFile(MemoName)
	return

	MemoCaseChange:
		Gui, 8:Default
		GuiControlGet, CaseDDL,,CaseDDL
		GuiControlGet, MemoPreview,,MemoPreview
		if (CaseDDL == "Upper")
			StringUpper, MemoPreview, MemoPreview
		if (CaseDDL == "Lower")
			StringLower, MemoPreview, MemoPreview
		if (CaseDDL == "Title")
			StringUpper, MemoPreview, MemoPreview, T
		if (CaseDDL == "Sentence")
		{
			StringLower, MemoPreview, MemoPreview		
			MemoPreview := RegExReplace(MemoPreview, "`a)(\.\s*.|^\s*.|`n\s*.)", "$U0")
		}
		GuiControl,,MemoPreview,%MemoPreview%
		GuiControl,,CaseDDL,|Upper|Lower|Sentence|Title
		GuiControl, Enable, SaveMemosButton
	return

	addMemo:
		gui, 8:default
		if !FileExist(MEMOS_PATH)
			FileCreateDir, %MEMOS_PATH%
		MemoName := GetNewMemoName("new_Memo")
		GuiControl, Focus, MemosList
		LV_Modify(LV_Add("", MemoName),"Focus Select Vis") ;adding and selecting new memo
		GuiControlSet("MemoEncrypt","","Enable",8,0)
		GuiControlSet("MemoDecrypt","","Disable",8,0)
		FileOpen(MEMOS_PATH . "\" . MemoName . ".mmo","w").Close()
		return

	DeleteMemo_contx: ;deleting memo from context menu
		Gui, 8:Default
		Gui, +OwnDialogs
		RowNumber := LV_GetNext()
		RowsCount := LV_GetCount()
		LV_GetText(MemoName, RowNumber)
		if MemosDelConfirm
		{
			MsgBox, 36, Delete Memo?, Delete "%MemoName%"?
			IfMsgBox, NO
				Return
		}
		LV_Delete(RowNumber)
		FileDelete, %MEMOS_PATH%\%MemoName%.mmo
		GuiControl,, MemoPreview
		GuiControl,, memoname_gui
		LV_Modify(RowNumber := RowNumber == 1 ? 1 : (RowNumber := RowsCount == RowNumber ? RowNumber-1 : RowNumber),"Select Vis")
		if (LV_GetCount() = 0)
		{
			GuiControlSet("MemoPreview|CaseDDL|SendMemoE|MemoEncrypt|MemoDecrypt","","Disable",8,0)
			GuiControl,,MemoPreview
		}
		RowsCount := RowNumber := ""
		return

	RenameMemo_contx: ;renaming memo from context menu
		Gui, 8:Default
		SendMessage( memoHwnd, LVM_EDITLABELW := 0x1000 + 118, LV_GetNext()-1, 0 )
		return

	MemoPreviewChanged:
		if AllowApplyButtonEnabling
			GuiControl, Enable, SaveMemosButton
		return


   	8GuiClose:
	8GuiEscape:
		Gui, 8:Default
		Gui, +OwnDialogs
		MemoCheckState()
		Gui, 8:Destroy
		Menu, MemosMenuBar, Delete
		Menu, MemosActions, Delete
		Menu, ChCase, Delete
		memo_edit_hwnd =
		SetTimer,DisMess,5000
		MemosGuiRunning := 0
		MemoMenu_MColor := GetMenuColor(MAIN_SECTION_NAME,"MenuColor")
		MemoMenu_TColor := GetMenuColor(MAIN_SECTION_NAME,"TextColor")
		MemosMenuRebuild(QC_MMenus[MAIN_SECTION_NAME],MemoMenu_MColor,MemoMenu_TColor,GetIconSize(),1)
		MemoMenu_MColor := MemoMenu_TColor := ""
		Hotkey("^s",0,"ApplyMemosChangesHK",1,"i)^\s*\Q" MEMOS_TITLE "\E\s*$")
		return
		
	OnMemoSelect:
		Gui, 8:Default
		Gui, +OwnDialogs
		if (A_GuiEvent == "I" && InStr(ErrorLevel, "s", 1))
			prevMemoRow := A_EventInfo
		;puts selected memo's content to the edit control
		else if (A_GuiEvent == "I" && InStr(ErrorLevel, "S", 1))
		{
			AllowContx := 1
			MemoCheckState(prevMemoRow)
			if memo_Old_Name	;in case if memo was not successfully renamed before switching to another
			{
				LV_Modify(last_renamed_memo, "", memo_Old_Name)
				DTP("Please use ""Enter"" to confirm memo renaming!")
				last_renamed_memo =
				memo_Old_Name =
			}
			AllowApplyButtonEnabling = 0
			GuiControlGet, state, Enabled, MemoPreview
			if !state
				GuiControlSet("MemoPreview|CaseDDL|SendMemoE","","Enable",8,0)	;Enabling edit control in case it was disabled (happens only when memos list empty)
			Free(state)
			GuiControl, Disable, SaveMemosButton			;disabling button "Apply Changes"
			SelectedRowNumber := A_EventInfo				;putting currently selected row number into global variable
			LV_GetText(MemoName, A_EventInfo)				;getting selected memo name
			GuiControl,,memoname_gui,%MemoName%				;puts selected memo name above edit control
			GuiControl,,MemoPreview							;emptying edit control
			GetMemoText(Memo,MemoName,0,0)		;reading content of selected memo	
			if (Memo = "")
			{
				AllowApplyButtonEnabling = 1
				return
			}
			MemoToCtrl(Memo,"MemoPreview")
			SetCryptControls()
			GuiControl, Focus, MemosList
			Sleep 50
			AllowApplyButtonEnabling = 1
		}
		else if (A_GuiEvent == "K") ;if button pressed, support for deleting memos
		{
			if A_EventInfo in 110,46 ;if "Del" pressed 
			{
				RowNumber := LV_GetNext()
				RowsCount := LV_GetCount()
				LV_GetText(MemoName, RowNumber)
				if MemosDelConfirm
				{
					MsgBox, 36, Delete Memo?, Delete "%MemoName%"?
					IfMsgBox, NO
							Return
				}
				LV_Delete(RowNumber)
				FileDelete, %MEMOS_PATH%\%MemoName%.mmo
				GuiControl,, MemoPreview
				GuiControl,, memoname_gui
				LV_Modify(RowNumber := RowNumber == 1 ? 1 : (RowNumber := RowsCount == RowNumber ? RowNumber-1 : RowNumber),"Select Vis")
				if (LV_GetCount() = 0)
				{
					GuiControlSet("MemoPreview|CaseDDL|SendMemoE|MemoEncrypt|MemoDecrypt","","Disable",8,0)
					GuiControl,,MemoPreview
				}
				RowsCount := RowNumber := ""
			}
			else if (A_EventInfo = 38 && LV_GetNext()=1 && AllowJumpList = 1) 				;if "Up" pressed while on the top of list
				LV_Modify(LV_GetCount(),"Select Focus Vis") 								;select last item from list
			else if (A_EventInfo = 40 && LV_GetNext()=LV_GetCount() && AllowJumpList = 1) 	;if "Down" pressed while on the last item from list
				LV_Modify(1,"Select Focus Vis")												;select item on the top of list
			else if (LV_GetNext() = LV_GetCount() || LV_GetNext() = 1)
				AllowJumpList := 1
			else
				AllowJumpList := 0
		}
		else if (A_GuiEvent == "E") ;support for editing memos name
			last_renamed_memo := A_EventInfo, LV_GetText(memo_Old_Name, last_renamed_memo)
		else if (A_GuiEvent == "e")
		{
			LV_GetText(memo_New_Name, last_renamed_memo)
			if (memo_New_Name == memo_Old_Name)
			{}
			else If (StrLen(memo_New_Name) > 190)
			{
				DTP("New memo name is too long! (max 190 chars)")
				LV_Modify(last_renamed_memo, "Select Vis", memo_Old_Name)			
			}
			else if RegExMatch(memo_New_Name,"[^0-9a-zA-Z!@#$%\^&()_\-+= ]+|^&|^\s*$")
			{
				DTP("Wrong Name!")
				LV_Modify(last_renamed_memo, "Select Vis", memo_Old_Name)
			}
			else If IsMemoExist(memo_New_Name)
			{
				DTP("This Memo already exists!")
				LV_Modify(last_renamed_memo, "Select Vis", memo_Old_Name)				
			}
			else
			{
				FileMove, %MEMOS_PATH%\%memo_Old_Name%.mmo,%MEMOS_PATH%\%memo_New_Name%.mmo,1
				if ErrorLevel
				{
					DTP("Could not rename memo!")
					LV_Modify(last_renamed_memo, "Select Vis", memo_Old_Name)
				}
				GuiControl,,memoname_gui,%memo_New_Name%
			}
			memo_Old_Name =
			last_renamed_memo =
		}
		else if (A_GuiEvent == "DoubleClick")
		{
			if LV_GetNext()
			{
				SendMessage( memoHwnd, LVM_EDITLABELW := 0x1000 + 118, A_EventInfo-1, 0 )
				last_renamed_memo := A_EventInfo, LV_GetText(memo_Old_Name, last_renamed_memo)
			}
			else
				GoSub, addMemo
		}
	return
		
	CryptThatShit:
		ProcessMemoEncrypt(A_GuiControl)
		return
}

IsMemoExist(memo_name)
{
	global MEMOS_PATH
	Loop, %MEMOS_PATH%\%memo_name%.mmo
			return 1
	return 0
}

ShowMemoOnTop(memo_Name)
{
	global
	if !GetMemoText(Memo_Text,memo_Name)
		return
	if (memo_Text == "")
	{
		DTP("Memo empty!")
		return
	}
	if (memoontop_gui == "" || memoontop_gui == 98)
		memoontop_gui := 30
	Else
		memoontop_gui++
	if (memoontop_gui == 77)
		memoontop_gui++
	
	Gui, %memoontop_gui%:+LastFoundExist
	IfWinExist
	{
		DTP("Existed Memo-On-Top replaced due to limits...",3000)
		Gui, %memoontop_gui%:Destroy
	}
	
	Gui, %memoontop_gui%:Default
	if global_NoGuiTheme
		Gui,-Theme
	Gui, Margin, 5, 5
	Gui,Add,Edit,xm ym -Theme W250 H250 +Multi vOnTopMemo%memoontop_gui% HWND%memoontop_gui%_edit_hwnd gOTM_Changed
	
	OTM_e_name = OnTopMemo%memoontop_gui%
	MemoToCtrl(Memo_Text,OTM_e_name,memoontop_gui)
	OTM_e_name =
	OTM_%memoontop_gui%_name := memo_Name
	;~ GuiControl,+ReadOnly, OnTopMemo%memoontop_gui%
	Gui,Add,Button,xm y+5 w80 h20 vOTM_Save_But%memoontop_gui% gsave_OTM_Changes Hidden,Save
	Gui,Add,Button,x+5 w100 h20 vOTM_SaveEncrypt%memoontop_gui% gsave_OTM_Changes Hidden,Encrypt && Save
	
	;creating menu bar for current gui

	Menu, %memoontop_gui%MenuBar, Delete
	Menu, %memoontop_gui%Tools, Add, Change Font, changefont
	Menu, %memoontop_gui%Tools, Add, Save Font as Default, fonttodefault
	Menu, %memoontop_gui%Tools, Add
	Menu, %memoontop_gui%Tools, Add, Change BG Color, change_color
	Menu, %memoontop_gui%Tools, Add, Change Text Color, change_color
	Menu, %memoontop_gui%Tools, Add, Set Random Colors, change_color
	Menu, %memoontop_gui%Tools, Add, Save Colors as Default, MakeColorsDefault
	Menu, %memoontop_gui%Tools, Add
	Menu, %memoontop_gui%Tools, Add, Always On Top, changeontoppness
	Menu, %memoontop_gui%Tools, Check, Always On Top
	Menu, %memoontop_gui%Tools, Add, Edit, edit_memo
	Menu, %memoontop_gui%MenuBar, Add, -<>-, :%memoontop_gui%Tools

	Gui, Menu, %memoontop_gui%MenuBar	
	
	ChoosedBGColor%memoontop_gui% := OptGet("OTM_bg_default_color")
	if ChoosedBGColor%memoontop_gui% is not Xdigit
		ChoosedBGColor%memoontop_gui% := "E0E0E0"
	ChoosedTextColor%memoontop_gui% := OptGet("OTM_t_default_color")
	if ChoosedTextColor%memoontop_gui% is not Xdigit
		ChoosedTextColor%memoontop_gui% := "0"	
	
	CColor(%memoontop_gui%_edit_hwnd,ChoosedBGColor%memoontop_gui%,ChoosedTextColor%memoontop_gui%)								;setting default colors
	
	OTM_GetDefaultFont(ChoosedFontName%memoontop_gui%, ChoosedStiles%memoontop_gui%)
	if (ChoosedFontName%memoontop_gui% || ChoosedStiles%memoontop_gui%)
	{
		gui, font,% "norm " ChoosedStiles%memoontop_gui%,% ChoosedFontName%memoontop_gui%
		GuiControl, Font, OnTopMemo%memoontop_gui%
	}	
	Gui, +LabelOnTopMemo +Resize MinSize200x200 +AlwaysOnTop +ToolWindow ;-SysMenu
	GUi, +LastFoundExist
	WinGet, %memoontop_gui%hwnd, ID
	WinSet, Redraw,,% "ahk_id " %memoontop_gui%hwnd
	Gui,Show,, %memo_Name%
	return
	
	OTM_Changed:
		Gui, %A_Gui%:Default
		GuiControlGet,state,Visible,OTM_Save_But%A_Gui%
		if !state
		{
			WinGetPos, X, Y, W, H,% "AHK_ID " %memoontop_gui%_edit_hwnd
			GuiControl, MoveDraw, OnTopMemo%A_Gui%,% "H" . (H-15)
			GuiControl, Show, OTM_Save_But%A_Gui%
			GuiControl, Show, OTM_SaveEncrypt%A_Gui%
		}
		else
		{
			GuiControl,MoveDraw,OnTopMemo%A_Gui%
		}
		return
	
	save_OTM_Changes:
		guinum := A_Gui
		Gui, %guinum%:Default
		ctrlname = OnTopMemo%guinum%
		if instr(A_GuiControl,"OTM_SaveEncrypt")
			r := SaveMemoToFile(OTM_%guinum%_name,ctrlname,guinum,1)
		else
			r := SaveMemoToFile(OTM_%guinum%_name,ctrlname,guinum)
		if !r
			return
		Gui, %guinum%:Default
		WinGetPos, X, Y, W, H,% "AHK_ID " %guinum%_edit_hwnd
		GuiControl, MoveDraw, OnTopMemo%guinum%,% "H" . (H+15)
		GuiControl, Hide, OTM_Save_But%guinum%
		GuiControl, Hide, OTM_SaveEncrypt%guinum%
		GuiControl, Focus,OTM_Save_But%guinum%
		return
	
	change_color:
		CC_Gui := A_Gui
		if (A_ThisMenuItem == "Change BG Color")
			ChoosedColor := "0x" ChoosedBGColor%A_Gui%			;set default color for color dialog to current
		else if (A_ThisMenuItem == "Change Text Color")
			ChoosedColor := "0x" ChoosedTextColor%A_Gui%		;set default color for color dialog to current
		else if (A_ThisMenuItem == "Set Random Colors")
		{
			CColor(%CC_Gui%_edit_hwnd, ChoosedBGColor%CC_Gui% := RandColor(), ChoosedTextColor%CC_Gui% := RandColor())
			WinSet, Redraw,,% "ahk_id " %CC_Gui%hwnd
			return
		}
		else return
		if Dlg_Color(ChoosedColor, %A_Gui%hwnd)
		{
			StringTrimLeft,ChoosedColor,ChoosedColor,2
			if (A_ThisMenuItem == "Change BG Color")
				CColor(%A_Gui%_edit_hwnd, ChoosedBGColor%A_Gui% := ChoosedColor, ChoosedTextColor%A_Gui%)
			if (A_ThisMenuItem == "Change Text Color")
				CColor(%A_Gui%_edit_hwnd, ChoosedBGColor%A_Gui%, ChoosedTextColor%A_Gui% := ChoosedColor)
			WinSet, Redraw,,% "ahk_id " %A_Gui%hwnd
			ChoosedColor =
		}
		return
	
	edit_memo:
		ThisGui := A_Gui
		gui, %ThisGui%:default
		Gui %ThisGui%:+LastFoundExist
		WinSet, AlwaysOnTop, Off
		Menu, %ThisGui%Tools, Uncheck, Always On Top
		Memos_Change_GUI()				;opening memos gui\
		WinWait, %MEMOS_TITLE%,,3		;waiting till gui appear
		gui, 8:default
		WinGetTitle, MemoName,% "ahk_id " %ThisGui%hwnd
		Loop,% LV_GetCount()
		{
			LV_GetText(TempMemoName, A_Index)
			if (TempMemoName = MemoName)
			{
				LV_Modify(A_Index,"Select Focus Vis") ;selecting memo for edit	
				break
			}
		}
		TempMemoName := MemoName := ""
		WinSet, Top,, %MEMOS_TITLE%						;putting memos gui to foreground
		return
	
	OnTopMemoClose:
	Gui, %A_Gui%:Destroy
	Menu, %A_Gui%MenuBar, Delete
	ChoosedBGColor%A_Gui% =
	ChoosedTextColor%A_Gui% = 
	%A_Gui%_edit_hwnd = 
	OnTopMemo%A_Gui% =
	%A_GUI%hwnd =
	memoontop_cb%A_GUI% =
	return
	
	OnTopMemoSize:
	Gui, %A_Gui%:Default
	GuiControlGet,save_vis,Visible,OTM_Save_But%A_Gui%
	GuiControl, MoveDraw, OnTopMemo%A_Gui%,% "W" . (A_GuiWidth-10) . A_Space . "H" . (A_GuiHeight-(save_vis ? 25 : 10))
	GuiControl, MoveDraw, OTM_Save_But%A_Gui%,% "Y" . (A_GuiHeight-20)
	GuiControl, MoveDraw, OTM_SaveEncrypt%A_Gui%,% "Y" . (A_GuiHeight-20)
	return
	
	changefont:
	Gui, %A_GUI%:Default
	if Dlg_Font(ChoosedFontName%A_GUI%, ChoosedStiles%A_GUI%, ChoosedColor,false, %A_GUI%hwnd)
	{
		gui, font,% "norm " ChoosedStiles%A_GUI%,% ChoosedFontName%A_GUI%
		GuiControl, Font, OnTopMemo%A_Gui%
	}
	return
	
	changeontoppness:
	Gui, %A_GUI%:Default
	Gui, +LastFoundExist
	Menu, %A_Gui%Tools, ToggleCheck, Always On Top
	WinSet, AlwaysOnTop, Toggle
	return
	
	MakeColorsDefault:
		OptSet("OTM_bg_default_color",ChoosedBGColor%A_Gui%)
		OptSet("OTM_t_default_color",ChoosedTextColor%A_Gui%)
		return
		
	fonttodefault:
		OTM_SaveFontAsDefault(ChoosedFontName%A_GUI%,ChoosedStiles%A_GUI%)
		return
}

OTM_GetDefaultFont(ByRef FontName,ByRef Styles)
{
	sFont := OptGet("OTM_default_font")
	if (sFont != "error" && sFont != "")
	{
		StringSplit,sFont,sFont,|,%A_Tab%%A_Space%
		FontName := sFont1
		Styles := sFont2
	}
	return
}

OTM_SaveFontAsDefault(FontName,Styles)
{
	if (FontName = "" && Styles = "")
		return
	OptSet("OTM_default_font",FontName . "|" . Styles)
	return
}

GetNewMemoName(mmo_Name)
{
	global MEMOS_PATH
	loop, %MEMOS_PATH%\%mmo_Name%.mmo
		mmo_Name := GetNewMemoName( NameGetNext(mmo_Name) )
	return mmo_Name
}

DisableMemosHotkeys() 
{
	global
	Memos_hotkey := OptGet("Memos_Hotkey")
	if (Memos_hotkey = "ERROR" || Memos_hotkey = "")
		Memos_hotkey := MEMOS_DEFAULT_HOTKEY
	Hotkey, %Memos_hotkey%, ShowMemos, OFF UseErrorLevel	
	return
}

ShowMemoPreview(memo_id,memo_name)
{
	global MEMOS_PATH, memo_preview=
	IfNotExist, %MEMOS_PATH%\%memo_name%.mmo
	{
		memo_preview .= "File Not Found!"
		SetTimer, ShoMemTLP, -200
		return
	}
	f := FileOpen(MEMOS_PATH . "\" . memo_name . ".mmo","r","CP0")
	if IsObject(f)
		loop
		{
			next_line := f.ReadLine()
			if (lines_count = 5 || f.AtEOF)
				break
			if RegExReplace(next_line,"`a)\s")
			{
				memo_preview .= next_line
				lines_count++
			}
		}
	f.Close()
	if (memo_preview = "")
		memo_preview := "Empty!"
	else
		memo_preview .= "..."
	SetTimer, ShoMemTLP, -500
	return
	
	ShoMemTLP:
		tooltip % memo_preview
		return
}

MemoToCtrl(MemoText,CtrlName,Gui = "") 
{	
	if (Gui = "")
		Gui := A_Gui
	GuiControlSet(CtrlName,MemoText,"",Gui)
	GuiControl,%Gui%: Focus, %CtrlName%
	return
}

MemoToClip(MemoName)
{
	global MEMOS_PATH, window
	if !GetMemoText(mTextC, MemoName)
		return
	if (mTextC == "")
		{
			DTP("Memo empty!")
			return
		}
	Clipboard := mTextC
	return
}

MemoToWindow(MemoName,win_hwnd)
{
	if !GetMemoText(MemoText, MemoName)
		return
	ClipHandl := ClipboardAll
	if (MemoText == "")
	{
		DTP("Memo empty!")
		Clipboard := ClipHandl
		return
	}
	Clipboard := MemoText
	ClipWait,3
	WinActivate, ahk_id %win_hwnd%
	WinWaitActive, ahk_id %win_hwnd%, , 1
	if ERRORLEVEL
	{
		Clipboard := ClipHandl
		DTP("Could not send to the window.`nPlease try again.")
		Return
	}
	SendInput, ^{vk56sc02F}					;ctrl+v - sending memo content to the active window
	sleep 300
	Clipboard := ClipHandl
	ClipHandl =	
	return
}

CopyMemoToFile(mName)		;this function is for copying memo to external txt
{
	global MEMOS_PATH
	
	if !GetMemoText(memo, mName)
		return
	FileSelectFile, OUT_FILE, s16, %mName%.txt
	If Errorlevel
		Return
	
	f := FileOpen(OUT_FILE,"w","CP0")
	if IsObject(f)
		f.Write(memo)
	f.Close()
	return
}

GetMemoText(ByRef mText, mName,EvalMetaSyntax = 1,checkForCrypt = 1)
{
	global MEMOS_PATH
	mText =
	f := FileOpen(MEMOS_PATH . "\" . mName . ".mmo","r","CP0")
	if IsObject(f)
		mText := f.Read()
	f.Close()
	
	StringReplace,mText,mText,`n,`r`n,1
	if (checkForCrypt && IsEncrypted(mText))
	{
		ret_str := MemoCrypt(mText,0)
		if (ret_str != "")
			mText := ret_str
		else
			return 0
	}
	if EvalMetaSyntax
		EvalMetaData(mText)
	return 1
}

MemosSaveChanges(row = "")
{
	Gui, 8:Default
	GuiControlGet, SaveMemosButton, Enabled, SaveMemosButton
	if !SaveMemosButton
		return
	LV_GetText( MemoName, row = "" ? LV_GetNext() : row )
	SaveMemoToFile(MemoName)
	GuiControl, Disable, SaveMemosButton
}

MemoCheckState(row = "")
{
	Gui, 8:Default
	GuiControlGet, state, Enabled, SaveMemosButton
	if state
	{
		MsgBox,68,Saving Memo,Last memo changes were not saved.`nDo you want to save them?
		IfMsgBox,Yes
			MemosSaveChanges(row)
	}
	return
}

SaveMemoToFile(mName,CtrlName = "",GuiNum = "",encrypt = "")			;this function is saving memo's changes back to file
{
	global MEMOS_PATH
	if (!CtrlName || !GuiNum)
		mText := GuiControlGet("MemoPreview",8)
	else
		mText := GuiControlGet(CtrlName,GuiNum)
	if (encrypt && mText != "")					;used to encrypt memo from OTM window
	{
		mText := MemoCrypt(mText,1,GuiNum)
		if !mText
			return 0
	}
	f := FileOpen(MEMOS_PATH . "\" . mName . ".mmo","w")
	if IsObject(f)
		f.Write(mText)
	f.Close()	
	return 1
}