﻿CurrentRecentItems( act, menu_handl )	;act = 1 to store items from the menu, 0 to add stored items to the new menu
{
	;This func saving the recent items from "menu_handle" menu or restoring them
	local item_id, item_title, item_icon, cur_icon_handle
	static curItems																;this var keeps stored items between saving & resotring actions
	if (act = 1)
	{
		Loop,% (MMenu_Count(menu_handl)-2)										;count of items in recent menu
		{
			item_id := MMenu_GetItemIDbyPos(menu_handl,A_Index)					;getting item id
			idx := MMenu_findItemByID( menu_handl, item_id )					;getting item index which is real id of the item as hex number
			item_title := MMenu_ItemProps[idx,"title"]							;getting item title
			cur_icon_handle := MMenu_ItemProps[idx,"hIcon"]						;getting current item's icon handle which is "UInt"
			item_icon := IconCopy(cur_icon_handle,0,1,0)						;copying icon to have different handle of the same icon, because initial one will be destroyed on menu destroying				
			curItems .= item_icon . "#" . item_id . "#" . item_title . "`n"		;saving item info line
		}
	}
	else
	{
		if (curItems = "")
			return
		Loop,Parse,curItems,`n,%A_Tab%%A_Space%									;parsing formerly saved lsit of items
		{
			if (A_LoopField = "")
				continue
			StringSplit,item_attr,A_LoopField,#,%A_Tab%%A_Space%
			MMenu_Add(menu_handl, item_attr3,item_attr1,"","i" . item_attr2)	;attr1 = icon handle, attr2 = item id, attr3 = item title 
		}
		curItems = 
	}
}

RecentStuff( MenuHandl, MColor="", TColor="", IconsSize=16)
{
	global ICON_OFFSET, RecentHandl, RECENT_ICO, RecentShowInMain, DeleteNotificationState, global_IconsOnly, global_itemNum
	;here we do some magic to save recent items from the menu we going to destroy. We need to remake menu to apply possible colors/icons changes
	;----
	CurrentRecentItems(1,RecentHandl)																	;getting current recent items
	SomeHandle := MMenu_Create("S" . IconsSize . " O" . ICON_OFFSET . " c" . MColor . " t" . TColor,global_LightMenu)	;creating SomeMenu which will be new RecentMenu a bit later
	MMenu_Destroy(RecentHandl)																			;destroying current Recent Menu with all items in it
	CurrentRecentItems(0,SomeHandle)																	;Restoring saved items to the SomeMenu
	RecentHandl := SomeHandle																			;making SomeMenu to be the new Recent Menu
	SomeHandle =
	;----
	MMenu_Add(RecentHandl)
	MMenu_Add(RecentHandl, "Clear List","","","iRecent_Clear")
	if GetRecentLogProcsState()
	{
		if !DeleteNotificationState									; need this check to avoid multiple trackers of closed processes be active at the same time
			EnableDeleteNotification()
	}
	if GetRecentLogFoldersState()
		FoldersTracker(1)
	else
		FoldersTracker(0)
	if GetRecentWinLog()
	{
		WindowsRecentTracker(1)
		if !last_windowsRecentItemTime
			CheckWindowsRecent(1)
	}
	else
		WindowsRecentTracker(0)
	if RecentShowInMain
	{
		div := ColDiv(global_itemNum)
		MMenu_Add(MenuHandl, "Recent",RECENT_ICO,"","iRecent_menu" . " m" . RecentHandl . div,global_IconsOnly)
		global_itemNum++
	}
	return
}

WindowsRecentTracker(state)
{
	if state
		SetTimer, Recent_CheckWindowsRecentFolder, 3000
	else
		SetTimer, Recent_CheckWindowsRecentFolder, OFF
	return
}

CheckWindowsRecent(isFirst = 0)					;if isFirst = 1, we getting last existing shortcut's modification time only
{
	global WIN_RECENT_FOLDER, last_windowsRecentItemTime
	Loop, % WIN_RECENT_FOLDER . "\*.lnk", 0, 0
	{
		if (last_windowsRecentItemTime = "")
			last_windowsRecentItemTime := A_LoopFileTimeModified
		cur_t := A_LoopFileTimeModified
		EnvSub, cur_t,% last_windowsRecentItemTime, Seconds
		if (cur_t > 0 || (cur_t=0 && prev_item_time = A_LoopFileTimeModified))												;if new shortcut appeared in Windows' Recent folder
		{
			last_windowsRecentItemTime := A_LoopFileTimeModified
			if (isFirst = 0)
			{
				FileGetShortcut, %A_LoopFileFullPath%, f_target
				SplitPath, f_target, f_name
				AddNewRecentItem(f_name,IconGetAssociated(f_target),A_Now + (prev_item_time ? 1 : 0) . "_" . GetItemID(f_name),f_target)	;increasing time by 1 second if this is second item added at the same time
				f_target := f_name := ""
			}
			prev_item_time := A_LoopFileTimeModified		;need this to check if two items where added at the same second
		}
	}
	return
}

FoldersTracker(state)
{
	global explorer_pid
	if state
	{
		SetTimer, Recent_CheckActiveFolders, 2000
		Process,Exist,explorer.exe
		if errorlevel
			explorer_pid := errorlevel	
	}
	else
		SetTimer, Recent_CheckActiveFolders, OFF
	return
}

WinGetProcID(whwnd)
{
	DllCall("GetWindowThreadProcessId","UPtr",whwnd,"UInt*",pro_id)
	return pro_id
}

CheckActiveFolders()
{
	static last_fol_list
	global explorer_pid
	WinGet, folder, List		; getting a list of all opened windows
	Loop,% folder				; getting a list of currently opened folders only
	{
		;~ WinGet,p_name, ProcessName,% "ahk_id " folder%A_INDEX%			;many page faults source
		win_pid := WinGetProcID(folder%A_INDEX%)
		if (explorer_pid == win_pid)
			cur_folders_list .= (A_Index = 1 ? "" : "`n") . folder%A_INDEX%
	}
	loop, parse, last_fol_list, `n, %A_Tab%%A_Space%	;checking if any of existed folders were closed, comparing current folders list to the previous
	{
		if (A_LoopField = "")
			continue
		StringSplit, fol, A_LoopField, |, %A_Tab%%A_Space%
		If InStr(cur_folders_list,fol1)
		{
			if (fol3 != GetFolderAddress(fol1))
				StringReplace, last_fol_list, last_fol_list,%A_LoopField%,% fol1 . "|" . WinGetTitle(fol1) . "|" . GetFolderAddress(fol1)
		}
		Else
		{
			IfExist, %fol3%			;checking if folder exist
				AddNewRecentItem(Fol2,"shell32.dll:3",A_Now . "_" . fol1,fol3)
			StringReplace, last_fol_list, last_fol_list,%A_LoopField%`n
		}
	}
	loop,parse,cur_folders_list, `n, %A_Tab%%A_Space%		;checking for a newly opened folders
	{
		if (A_LoopField = "")
			continue
		if !InStr(last_fol_list,A_LoopField)
			last_fol_list .= A_LoopField . "|" . WinGetTitle(A_LoopField) . "|" . GetFolderAddress(A_LoopField) . "`n"
	}
	return
}

GetFolderAddress(pHWND)
{
	WinGetText, win_text, ahk_id %pHWND%
	if A_OSVersion in WIN_VISTA,WIN_7
	{
		RegExMatch(win_text,"im)^Address:\s*.*$",fol_address)
		fol_address := RegExReplace(fol_address,"i)^Address:\s*")
	}
	else if A_OSVersion in WIN_XP,WIN_2003,WIN_2000
		RegExMatch(win_text,"im)^\s*.*$",fol_address)
	return fol_address
}

StopClProcNotify()
{
	global
	ObjRelease(winmgmts)
	ObjRelease(deleteSink)
	winmgmts := deleteSink := DeleteNotificationState := ""	;if not free this vars, crash may occur after enabling-disabling-open-close gui
	return
}

EnableDeleteNotification()
{
	global
	winmgmts := ComObjGet("winmgmts:")
	deleteSink := ComObjCreate("WbemScripting.SWbemSink")
	ComObjConnect(deleteSink,"ProcessDelete_")
	interval := 1
	winmgmts.ExecNotificationQueryAsync(deleteSink, "SELECT * FROM __InstanceDeletionEvent WITHIN " . interval . " WHERE TargetInstance ISA 'Win32_Process'")
	SetIgnoredProcessList()
	DeleteNotificationState := 1
	return
}

; Called when a process terminates:
ProcessDelete_OnObjectReady(objWbemObject,objWbemAsyncContext) 
{
	global
	local proc
	proc := objWbemObject.TargetInstance
	;http://msdn.microsoft.com/en-us/library/aa394372.aspx
	proc_cmd := proc.CommandLine
	proc_name := proc.Name
	proc_exe := proc.ExecutablePath
	;~ proc_pID := proc.ParentProcessID
	proc_ID := proc.Handle
	
	if (proc_exe = "" || proc_cmd = "" || InStr(proc_cmd,"Windows\Servicing") || instr(IgnoredProcList,proc_name))
		return
	HandleClosedProcess()
	return
}

SetIgnoredProcessList()
{
	global
	IgnoredProcList = 
	(
SearchFilterHost.exe
SearchProtocolHost.exe
svchost.exe
dllhost.exe
	)
	StringReplace, IgnoredProcList, IgnoredProcList,`n,`,,1
	return IgnoredProcList
}

HandleClosedProcess()
{
	global
	SetTimer, ClosedProcProcessing, -1
	return
	
	ClosedProcProcessing:
		AddNewRecentItem(proc_name, IconGetAssociated(proc_exe), GetItemId(A_Now . "_" . proc_ID "_" proc_name),proc_cmd)
		return
}