﻿StoreRecentCmd(id,cmd_line)
{
	global
	RecentCmdsList .= id . "#" . cmd_line . "`n"
	return
}

GetRecentCmd(id,dl=1)
{
	global
	Loop, Parse, RecentCmdsList, `n, %A_Tab%%A_Space%
	{
		if (A_LoopField = "")
			Continue
		If InStr(A_LoopField,id)
		{
			StringReplace, cmd_line, A_LoopField,% id . "#"			;removing id from command line
			if dl
				StringReplace, RecentCmdsList, RecentCmdsList,% A_LoopField "`n"	;removing this command from the cmds list
			break
		}
	}
	if dl
		MMenu_Remove(RecentHandl,id)			;removing item from menu
	return cmd_line
}

RecentProcessActions(ID)
{
	if (ID = "Recent_Clear")
	{
		ClearRecentItems()
		return
	}
	RunTarget(GetRecentCmd(id),0,"","",1)		;with option "DontLog"
	return
}

ClearRecentItems()
{
	global
	local cnt
	RecentCmdsList =
	Loop,% (MMenu_Count(RecentHandl)-2)
		MMenu_Remove(RecentHandl,1)
	return
}

AddNewRecentItem(name,icon,id,cmd_line)
{
	global RecentHandl
	if (name = "" || cmd_line = "" || id="")
		return
	max_items := GetRCItemsCount()
	menu_items := MMenu_Count(RecentHandl)
	if (menu_items >= max_items+2)
		loop,% (menu_items-max_items-1)
		{
			item_id := MMenu_GetItemIDbyPos(RecentHandl,max_items)
			GetRecentCmd(item_id)	;removing this item's cmd from the cmds list
		}
	recent_item_id := "Recent_ii_" . id
	MMenu_Add(RecentHandl,name,icon,1,"i" . recent_item_id)
	StoreRecentCmd(recent_item_id,cmd_line)
	return
}

DisableRecentHotkeys()
{
	global RecentHandl
	Hotkey(GetRecentHotkey(),0,"ShowRecent")
	FoldersTracker(0)
	WindowsRecentTracker(0)
	MMenu_Destroy(RecentHandl)
	RecentHandl =
	RecentCmdsList =
	StopClProcNotify()
	return
}

ShowRecentItemTooltip(pID)
{
	global M_SID, rID
	rID := pID
	
	SetTimer, ShoRTP, -700
	return
	
	ShoRTP:
	if (rID = M_SID)
	{
		cmd := GetRecentCmd(rID,0)
		StringReplace,cmd, cmd,{N},`n,1
		Tooltip % GetTimeFormat(SubSTR(rID,11,14),"h:mm:ss dd/MM") "`n" cmd
		cmd =
	}
	return
}