﻿#SingleInstance Force
#NoEnv
#NoTrayIcon
#Persistent

#Include ..\include\Crypt.ahk
#Include ..\include\CryptConst.ahk

SetBatchLines, -1
Process, priority,,H

params = %0%
if !params ;close updater if started without parameters (launched manually)
	{
		SplashWait(1,"WTF...`nHow did you find me??")
		sleep 1000
		ExitApp
	}
APP_PID = %1%
APP_PATH = %2%
CUR_APP_VER = %3%
NEW_APP_VER = %4%
CUR_ARCH = %5%
QC_DATA_PATH := PathGetDir( APP_PATH ) . "\Data"
if (NEW_APP_VER = "")
	NEW_APP_VER := 0.81
if (CUR_ARCH = "x64")
	LAST_VER_APP_EXE := "http://apathysoftworks.com/QC/qc_update/" . NEW_APP_VER . "/QCx64.exe" ;where the new version of app is placed
else
	LAST_VER_APP_EXE := "http://apathysoftworks.com/QC/qc_update/" . NEW_APP_VER . "/QC.exe" ;where the new version of app is placed
CHANGELOG_URL := "http://apathysoftworks.com/QC/qc_update/changelog.txt"
if (CUR_ARCH = "x64")
	HASH_URL := "http://apathysoftworks.com/QC/qc_update/qc_sha_hash64"
else
	HASH_URL := "http://apathysoftworks.com/QC/qc_update/qc_sha_hash"
HASH_TEMP = %A_Temp%\qc_sha_hash
TEMP_DIR = %A_Temp%\QC_last_ver.exe
CHANGELOG_TEMP_PATH = %A_Temp%\changelog.txt
FileDelete, %TEMP_DIR%
FileDelete, %CHANGELOG_TEMP_PATH%
ShowChangeLog := 1

SplashWait(1,"Program will be updated`nand restarted shortly...")
sleep 100
URLDownloadToFile, %LAST_VER_APP_EXE%, %TEMP_DIR% ;downloading latest app version
	if ErrorLevel
	{
		SplashWait(0)
		MsgBox,,Error, Updater Error.`nPlease try again later.`nerror code 4
		ExitApp
	}
	FileGetSize, app_Size, %TEMP_DIR%
	if (app_Size < 1024) ;checking that file downloaded properly
	{
		SplashWait(0)
		MsgBox,,Error, Updater Error.`nPlease check your internet connection and try again later.`nerror code 7
		ExitApp
}

URLDownloadToFile, %HASH_URL%, %HASH_TEMP% ;downloading latest app version
f := FileOpen(HASH_TEMP,"r","CP0")
qc_hash := f.Read()
f.Close
qc_hash := RegExReplace(qc_hash,"`a)(\s|`n)")
sha_hash := Crypt.Hash.FileHash(TEMP_DIR,3)
if (qc_hash != sha_hash)
{
	SplashWait(0)
	MsgBox,,Error, Updater Error.`nThe HASH of the downloaded file is not valid.`nPlease check your download settings and try again.`n`nHASH:`n%sha_hash%`nValid HASH:`n %qc_hash%
	ExitApp
}

Process, Close, %APP_PID%
if (ErrorLevel=0)
{
	DetectHiddenWindows,On
	SendMessage, 0x7779,0,0,,ahk_pid %APP_PID%
		if ErrorLevel
		{
			SplashWait(0)
			MsgBox,,Error, Updater Error.`nPlease try again later.`nerror code 5
			ExitApp
		}
	DetectHiddenWindows,OFF
}
Remove_Include_Files( QC_DATA_PATH )
URLDownloadToFile, %CHANGELOG_URL%, %CHANGELOG_TEMP_PATH% ;downloading latest app version
	if ErrorLevel
		ShowChangeLog := 0
	FileRead,change_log,%CHANGELOG_TEMP_PATH%
	if ErrorLevel
		ShowChangeLog := 0
	if RegExMatch(change_log,"404|403|401|400|500|502|503|Bad file request|Connection refused by host|Failed DNS lookup|Host unavailable|Host unknown|Network connection was refused by the server|Permission denied|Too many connections|Too many users") ;if file was failed to download	
		ShowChangeLog := 0

sleep 2000
FileCopy, %TEMP_DIR%, %APP_PATH%, 1 ;copying new RanIt version in the place of previous (overwriting)
	if ErrorLevel
	{
		SplashWait(0)
		MsgBox,,Error, Updater Error.`nPlease try again later.`nerror code 6
		ExitApp
	}
SplashWait(1,"Done")
Run, %APP_PATH%,,UseErrorLevel
	if (ErrorLevel == "ERROR")
	{
		SplashWait(0)
		MsgBox,,Error, Failed to run app.`nerror code 8
		ExitApp
	}
Sleep 1000
SplashWait(0)
FileDelete, %TEMP_DIR%
if ShowChangeLog
{
	Gui, 29:Default
	Gui,Add,Edit, vchange_log_ed w400 h300 +Multi +ReadOnly, %change_log%
	GuiControl, Focus, change_log_ed
	Gui, +ToolWindow
	Gui,Show,, Change log
	return
}
else
	ExitApp

29GuiClose:
	ExitApp
	
VerCompare(num1,num2)
{
	if RegExMatch(num2,".*?(?=b\d+\s*$)", match )
	{
		num1 := RegExReplace(num1,"[^0-9]")
		num2 := RegExReplace(match,"[^0-9]")
		res := num1 >= num2
	}
	else {
		num1 := RegExReplace(num1,"[^0-9]")
		num2 :=	RegExReplace(num2,"[^0-9]")
		res := num1 > num2
	}
	return res
}

Free(byRef var)
{
	VarSetCapacity(var,0)
	return
}

Remove_Include_Files( qc_data_path ) {		;Function to delete all include files!
	FileDelete, %qc_data_path%\qc_icons.icl
}

PathIsDir( path )
{
	return DllCall( "Shlwapi\PathIsDirectoryW", "WStr", path )
}

PathGetDir( path )
{
	if PathIsDir( path )
	{
		DllCall( "Shlwapi\PathRemoveBackslashW", "WStr", path )
		return path
	}
	else
	{
		DllCall( "Shlwapi\PathRemoveFileSpecW", "WStr", path )
		return path
	}
}

;############################### SPLASH WAIT
SplashWait(mode,text = "",nGui = 1,OnTop = 1,SplashIndex = 7,DisableAfter=0) 
{
	static static_index,static_gui
	static_index := SplashIndex, static_gui := nGui
	if nGui
	{
		Gui, %nGui%:Default
		Gui, +OwnDialogs
		Gui, +Disabled
		Gui, +LastFoundExist
		WinGetPos, X, Y, W, H,% "AHK_ID " WinExist()
		si_pos := (x ? (" x" . (x+w/2-w/4)) : "") . (Y ? (" y" . (y+h/2-15)) : "") . " w" . (w ? w/2 : 250) . " h40"
	}
	if (mode = 1)
	{
		if !text
			text := "Please Wait..."
		if nGui
		{
			
		}
		SplashImage,%SplashIndex%:,% "FS10 B CW405871 CTffffff " (OnTop ? "" : "A") . si_pos,% text
	}
	else if (mode = 0)
		SetTimer,DSI,-5
	else if (mode = -1)	{
		SplashImage, %static_index%: Off
		if static_gui
			Gui, %static_gui%:-Disabled
	}
	if DisableAfter
		SetTimer,DSI,% "-" DisableAfter
	return
	
	DSI:
		SplashImage, %static_index%: Off
		if static_gui
			Gui, %static_gui%:-Disabled
		return
}